// Create the XHR object.
function createCORSRequestTDD(method, url) {
  	var xhr = new XMLHttpRequest();
  	if ("withCredentials" in xhr) {
    		// XHR for Chrome/Firefox/Opera/Safari.
    		xhr.open(method, url, true);
  	} else if (typeof XDomainRequest != "undefined") {
    		// XDomainRequest for IE.
    		xhr = new XDomainRequest();
    		xhr.open(method, url);
  	} else {
    		// CORS not supported.
    		xhr = null;
  	}
  	return xhr;
}

// Make the actual CORS request.
function makeCorsRequestTDD(xmlDoc, stage) {
	var url;
	if (CRAEPS) {
		url = "https://apps-ct.cra-arc.gc.ca/ebci/awsc/tdd/ws/" + taxYear + "/CertTestDeliveryService";
	}
	else {
		url = "https://apps.cra-arc.gc.ca/ebci/awsc/tdd/ws/" + taxYear + "/TaxDataDeliveryService";
	}
// All HTML5 Rocks properties support CORS.
	var xhr = createCORSRequestTDD('POST', url);
	xhr.withCredentials = true;
//	if (xmlDoc.xmlEncoding == "UTF-8") {
		xhr.setRequestHeader("Content-type","text/xml; charset=UTF-8");
//	}
//	else {
//		xhr.setRequestHeader("Content-type","text/xml;");
//	}
	if (stage == 1) {
		xhr.setRequestHeader("SOAPAction","StageTDDNetfile")
	}
	else if (stage == 2) {
		xhr.setRequestHeader("SOAPAction","GetTDDNetfile");
	}
  	if (!xhr) {
    		showDialogBox('CORS not supported');
    		return;
  	}
 
  	// Response handlers.
  	xhr.onload = function() {
    	var text = xhr.responseText;
 		console.log('Response from CORS request to ' + url + ': ' + text);
		xmlDoc=xhr.responseXML;
		ResponseHandlerTDD(xmlDoc);
		var tmpStr = "";
		if (SoapResponseType == "TermsAndConditions") {
			tmpStr = "<p><strong>Terms + Conditions and Privacy Notice</strong></p>" + "\n";
			tmpStr = tmpStr + "<p>" + termTextEn + "</p>" + "\n"
			tmpStr = tmpStr + "<p>" + termTextFr + "</p>" + "\n"
		}
		else if (SoapResponseType == "Confirmation") {
			tmpStr = "<p><strong>" + "Confirmation" + "</strong></p>" + "\n";
			tmpStr = tmpStr +"<p>" + "Confirmation code: " + ConfirmationCode + "</p>" + "\n";
		}
		else if (SoapResponseType == "ProcessingError") {
			tmpStr = "<p><strong>" + "Processing Error" + "</strong></p>" + "\n";
		}
		else if (SoapResponseType == "Rejection") {
			tmpStr = "<p><strong>" + "Rejection" + "</strong></p>" + "\n";
		}
		else if (SoapResponseType == "SystemError") {
			tmpStr = "<p><strong>" + "System Error" + "</strong></p>" + "\n";
		}
    
		tmpStr = tmpStr + "<p>" + soapMsgTextEn + "</p>" + "\n";
		tmpStr = tmpStr + "<p>" + soapMsgTextFr + "</p>" + "\n";
		for (i = 0; i <= 15; i++) {
			if (getErrorCode(i).length != 0) {
				tmpStr = tmpStr + "<p><br><br>Error code: " + getErrorCode(i) + "\n";
				tmpStr = tmpStr + getErrorMsgEn(i) + "\n";
				tmpStr = tmpStr + getErrorMsgFr(i) + "</p>" + "\n";
			}
		}
		if (SoapResponseType == "TermsAndConditions") {
			document.querySelector('#termResult').innerHTML = tmpStr;
 			if (document.querySelector('#termlinkEn') != null) {
				termlinkClicked = false;
				document.querySelector('#termlinkEn').addEventListener("click", function(evt) {
	  				setTermLink();
				});
			}
			if (document.querySelector('#termlinkFr') != null) {
				termlinkClicked = false;
				document.querySelector('#termlinkFr').addEventListener("click", function(evt) {
	  				setTermLink();
				});
			}
			document.getElementById('acceptTermBtn').style.display="block";
		}
		else {
			if (netfileMethod == 2) {
				tmpStr = "<p><strong>" + "Netfile result for Tax Return:" + "</strong></p>" + "\n" + tmpStr;
			}
			else if (netfileMethod == 12) {
				tmpStr = "<p><strong>" + "Netfile result for form T1135:" + "</strong></p>" + "\n" + tmpStr;
			}
			document.querySelector('#uploadResult').innerHTML = tmpStr;		
//			document.getElementById('uploadNetfile').style.display="block";
		}
	};

  	xhr.onerror = function() {
   		showDialogBox('Woops, there was an error making the request.');
                document.getElementById('cratdd').style.display="block";
	};

 	xhr.send(xmlDoc);
}
