// Create the XHR object.
function createCORSRequest(method, url) {
  	var xhr = new XMLHttpRequest();
  	if ("withCredentials" in xhr) {
    		// XHR for Chrome/Firefox/Opera/Safari.
    		xhr.open(method, url, true);
  	} else if (typeof XDomainRequest != "undefined") {
    		// XDomainRequest for IE.
    		xhr = new XDomainRequest();
    		xhr.open(method, url);
  	} else {
    		// CORS not supported.
    		xhr = null;
  	}
  	return xhr;
}

// Make the actual CORS request.
function makeCorsRequest(xmlDoc, stage) {
	var url;
	if (netfileMethod == 2) {
		if (CRAEPS) {
			url = "https://apps-ct.cra-arc.gc.ca/ebci/pfno/ws/services/FileReturnService";
		}
		else {
			url = "https://apps.cra-arc.gc.ca/ebci/pfno/ws/services/FileReturnService";
		}
	}
	else if (netfileMethod == 12) {
		if (CRAEPS) {
			url = "https://apps-ct.cra-arc.gc.ca/ebci/efes/frrms/ws/services/FileFormService";
		}
		else {
			url = "https://apps.cra-arc.gc.ca/ebci/efes/frrms/ws/services/FileFormService";
		}
	}
	else {
    	showDialogBox('Unrecongnized Web Service type.');
    	return;
	}
// All HTML5 Rocks properties support CORS.
	var xhr = createCORSRequest('POST', url);
	xhr.withCredentials = true;
//	if (xmlDoc.xmlEncoding == "UTF-8") {
		xhr.setRequestHeader("Content-type","text/xml; charset=UTF-8");
//	}
//	else {
//		xhr.setRequestHeader("Content-type","text/xml;");
//	}
	if (stage == 1) {
		xhr.setRequestHeader("SOAPAction","TermsAndConditionsRequest")
	}
	else if (stage == 2) {
		xhr.setRequestHeader("SOAPAction","FileReturnRequest");
	}
  	if (!xhr) {
    		showDialogBox('CORS not supported');
    		return;
  	}
 
  	// Response handlers.
  	xhr.onload = function() {
    	var text = xhr.responseText;
 		console.log('Response from CORS request to ' + url + ': ' + text);
		xmlDoc=xhr.responseXML;
		ResponseHandler(xmlDoc);
		var tmpStr = "";
		if (SoapResponseType == "TermsAndConditions") {
			tmpStr = "<p><strong>Terms + Conditions and Privacy Notice</strong></p>" + "\n";
			tmpStr = tmpStr + "<p>" + termTextEn + "</p>" + "\n"
			tmpStr = tmpStr + "<p>" + termTextFr + "</p>" + "\n"
		}
		else if (SoapResponseType == "Confirmation") {
			tmpStr = "<p><strong>" + "Confirmation" + "</strong></p>" + "\n";
			tmpStr = tmpStr +"<p>" + "Confirmation code: " + ConfirmationCode + "</p>" + "\n";
		}
		else if (SoapResponseType == "ProcessingError") {
			tmpStr = "<p><strong>" + "Processing Error" + "</strong></p>" + "\n";
		}
		else if (SoapResponseType == "Rejection") {
			tmpStr = "<p><strong>" + "Rejection" + "</strong></p>" + "\n";
		}
		else if (SoapResponseType == "SystemError") {
			tmpStr = "<p><strong>" + "System Error" + "</strong></p>" + "\n";
		}
    
		tmpStr = tmpStr + "<p>" + soapMsgTextEn + "</p>" + "\n";
		tmpStr = tmpStr + "<p>" + soapMsgTextFr + "</p>" + "\n";
		for (i = 0; i <= 15; i++) {
			if (getErrorCode(i).length != 0) {
				tmpStr = tmpStr + "<p><br><br>Error code: " + getErrorCode(i) + "\n";
				tmpStr = tmpStr + getErrorMsgEn(i) + "\n";
				tmpStr = tmpStr + getErrorMsgFr(i) + "</p>" + "\n";
			}
		}
		if (SoapResponseType == "TermsAndConditions") {
			document.querySelector('#termResult').innerHTML = tmpStr;
 			if (document.querySelector('#termlinkEn') != null) {
				termlinkClicked = false;
				document.querySelector('#termlinkEn').addEventListener("click", function(evt) {
	  				setTermLink();
				});
			}
			if (document.querySelector('#termlinkFr') != null) {
				termlinkClicked = false;
				document.querySelector('#termlinkFr').addEventListener("click", function(evt) {
	  				setTermLink();
				});
			}
			document.getElementById('acceptTermBtn').style.display="block";
		}
		else {
			if (netfileMethod == 2) {
				tmpStr = "<p><strong>" + "Netfile result for Tax Return:" + "</strong></p>" + "\n" + tmpStr;
			}
			else if (netfileMethod == 12) {
				tmpStr = "<p><strong>" + "Netfile result for form T1135:" + "</strong></p>" + "\n" + tmpStr;
			}
			document.querySelector('#uploadResult').innerHTML = tmpStr;		
			document.getElementById('uploadNetfile').style.display="block";
		}
	};

  	xhr.onerror = function() {
   		showDialogBox('Woops, there was an error making the request.');
 	};

 	xhr.send(xmlDoc);
}
// Create the XHR object.
function createCORSRequestTDD(method, url) {
  	var xhr = new XMLHttpRequest();
  	if ("withCredentials" in xhr) {
    		// XHR for Chrome/Firefox/Opera/Safari.
    		xhr.open(method, url, true);
  	} else if (typeof XDomainRequest != "undefined") {
    		// XDomainRequest for IE.
    		xhr = new XDomainRequest();
    		xhr.open(method, url);
  	} else {
    		// CORS not supported.
    		xhr = null;
  	}
  	return xhr;
}

// Make the actual CORS request.
function makeCorsRequestTDD(xmlDoc, stage) {
	var url;
	if (CRAEPS) {
		url = "https://apps-ct.cra-arc.gc.ca/ebci/awsc/tdd/ws/" + taxYear + "/CertTestDeliveryService";
	}
	else {
		url = "https://apps.cra-arc.gc.ca/ebci/awsc/tdd/ws/" + taxYear + "/TaxDataDeliveryService";
	}
// All HTML5 Rocks properties support CORS.
	var xhr = createCORSRequestTDD('POST', url);
	xhr.withCredentials = true;
//	if (xmlDoc.xmlEncoding == "UTF-8") {
		xhr.setRequestHeader("Content-type","text/xml; charset=UTF-8");
//	}
//	else {
//		xhr.setRequestHeader("Content-type","text/xml;");
//	}
	if (stage == 1) {
		xhr.setRequestHeader("SOAPAction","StageTDDNetfile")
	}
	else if (stage == 2) {
		xhr.setRequestHeader("SOAPAction","GetTDDNetfile");
	}
  	if (!xhr) {
    		showDialogBox('CORS not supported');
    		return;
  	}
 
  	// Response handlers.
  	xhr.onload = function() {
    	var text = xhr.responseText;
 		console.log('Response from CORS request to ' + url + ': ' + text);
		xmlDoc=xhr.responseXML;
		ResponseHandlerTDD(xmlDoc);
		var tmpStr = "";
		if (SoapResponseType == "TermsAndConditions") {
			tmpStr = "<p><strong>Terms + Conditions and Privacy Notice</strong></p>" + "\n";
			tmpStr = tmpStr + "<p>" + termTextEn + "</p>" + "\n"
			tmpStr = tmpStr + "<p>" + termTextFr + "</p>" + "\n"
		}
		else if (SoapResponseType == "Confirmation") {
			tmpStr = "<p><strong>" + "Confirmation" + "</strong></p>" + "\n";
			tmpStr = tmpStr +"<p>" + "Confirmation code: " + ConfirmationCode + "</p>" + "\n";
		}
		else if (SoapResponseType == "ProcessingError") {
			tmpStr = "<p><strong>" + "Processing Error" + "</strong></p>" + "\n";
		}
		else if (SoapResponseType == "Rejection") {
			tmpStr = "<p><strong>" + "Rejection" + "</strong></p>" + "\n";
		}
		else if (SoapResponseType == "SystemError") {
			tmpStr = "<p><strong>" + "System Error" + "</strong></p>" + "\n";
		}
    
		tmpStr = tmpStr + "<p>" + soapMsgTextEn + "</p>" + "\n";
		tmpStr = tmpStr + "<p>" + soapMsgTextFr + "</p>" + "\n";
		for (i = 0; i <= 15; i++) {
			if (getErrorCode(i).length != 0) {
				tmpStr = tmpStr + "<p><br><br>Error code: " + getErrorCode(i) + "\n";
				tmpStr = tmpStr + getErrorMsgEn(i) + "\n";
				tmpStr = tmpStr + getErrorMsgFr(i) + "</p>" + "\n";
			}
		}
		if (SoapResponseType == "TermsAndConditions") {
			document.querySelector('#termResult').innerHTML = tmpStr;
 			if (document.querySelector('#termlinkEn') != null) {
				termlinkClicked = false;
				document.querySelector('#termlinkEn').addEventListener("click", function(evt) {
	  				setTermLink();
				});
			}
			if (document.querySelector('#termlinkFr') != null) {
				termlinkClicked = false;
				document.querySelector('#termlinkFr').addEventListener("click", function(evt) {
	  				setTermLink();
				});
			}
			document.getElementById('acceptTermBtn').style.display="block";
		}
		else {
			if (netfileMethod == 2) {
				tmpStr = "<p><strong>" + "Netfile result for Tax Return:" + "</strong></p>" + "\n" + tmpStr;
			}
			else if (netfileMethod == 12) {
				tmpStr = "<p><strong>" + "Netfile result for form T1135:" + "</strong></p>" + "\n" + tmpStr;
			}
			document.querySelector('#uploadResult').innerHTML = tmpStr;		
//			document.getElementById('uploadNetfile').style.display="block";
		}
	};

  	xhr.onerror = function() {
   		showDialogBox('Woops, there was an error making the request.');
                document.getElementById('cratdd').style.display="block";
	};

 	xhr.send(xmlDoc);
}
window.addEventListener("load", function(e) {
	var dialog = document.querySelector('#dialog1');
/*
	document.querySelector('#show').addEventListener("click", function(evt) {
		dialog.showModal();
	});
*/
	document.querySelector('#close').addEventListener("click", function(evt) {
		dialog.close("thanks!");
	});

	dialog.addEventListener("close", function(evt) {
//		document.querySelector('#result').textContent = "You closed the dialog with: " + dialog.returnValue;
	});

	// called when the user Cancels the dialog, for example by hitting the ESC key
	dialog.addEventListener("cancel", function(evt) {
		dialog.close("canceled");
	});
});
//Show dialogBox.
function showDialogBox(message) {
	var dialog = document.querySelector('#dialog1');
	document.querySelector('#dialogTitle').textContent = "";
	document.querySelector('#dialogContent').textContent = message;
	dialog.showModal();

}
//Show dialogBox.
function showDialogBox1(title, message) {
	var dialog = document.querySelector('#dialog1');
	document.querySelector('#dialogTitle').textContent = title;
	document.querySelector('#dialogContent').textContent = message;
	dialog.showModal();

}
onload = function() {
  var start = document.getElementById("start");
  var stop = document.getElementById("stop");
  var hosts = document.getElementById("hosts");
  var port = document.getElementById("port");
  var portLine = document.getElementById("portLine");
  var directory = document.getElementById("directory");

  var tcpServer = chrome.sockets.tcpServer;
  var tcpSocket = chrome.sockets.tcp;

  var serverSocketId = null;
  var filesMap = {};
  var send2CRA;

  var stringToUint8Array = function(string) {
    var buffer = new ArrayBuffer(string.length);
    var view = new Uint8Array(buffer);
    for (var i = 0; i < string.length; i++) {
      view[i] = string.charCodeAt(i);
    }
    return view;
  };

  var arrayBufferToString = function(buffer) {
    var str = '';
    var uArrayVal = new Uint8Array(buffer);
    for (var s = 0; s < uArrayVal.length; s++) {
      str += String.fromCharCode(uArrayVal[s]);
    }
    return str;
  };

  var logToScreen = function(log) {
    logger.textContent += log + "\n";
    logger.scrollTop = logger.scrollHeight;
  };

  var destroySocketById = function(socketId) {
    tcpSocket.disconnect(socketId, function() {
      tcpSocket.close(socketId);
    });
  };

  var closeServerSocket = function() {
    if (serverSocketId) {
      tcpServer.close(serverSocketId, function() {
        if (chrome.runtime.lastError) {
          console.warn("chrome.sockets.tcpServer.close:", chrome.runtime.lastError);
        }
      });
    }

    tcpServer.onAccept.removeListener(onAccept);
    tcpSocket.onReceive.removeListener(onReceive);
  };

  var sendReplyToSocket = function(socketId, buffer, keepAlive) {
    // verify that socket is still connected before trying to send data
    tcpSocket.getInfo(socketId, function(socketInfo) {
      if (!socketInfo.connected) {
        destroySocketById(socketId);
        return;
      }

      tcpSocket.setKeepAlive(socketId, keepAlive, 1, function() {
        if (!chrome.runtime.lastError) {
          tcpSocket.send(socketId, buffer, function(writeInfo) {
            console.log("WRITE", writeInfo);

            if (!keepAlive || chrome.runtime.lastError) {
              destroySocketById(socketId);
            }
          });
        }
        else {
          console.warn("chrome.sockets.tcp.setKeepAlive:", chrome.runtime.lastError);
          destroySocketById(socketId);
        }
      });
    });
  };

  var getResponseHeader = function(file, errorCode, keepAlive) {
    var httpStatus = "HTTP/1.0 200 OK";
    var contentType = "text/html";
    var contentLength = 0;

    if (!file || errorCode) {
      httpStatus = "HTTP/1.0 " + (errorCode || 404) + " Not Found";
    }
    else {
      contentType = file.type || contentType;
      contentLength = file.size;
    }

    var lines = [
      httpStatus,
      "Content-length: " + contentLength,
      "Content-type:" + contentType
    ];

    if (keepAlive) {
      lines.push("Connection: keep-alive");
    }

    return stringToUint8Array(lines.join("\n") + "\n\n");
  };

  var getResponseHeader = function(file, errorCode, keepAlive) {
    var httpStatus = "HTTP/1.0 200 OK";
    var contentType = "text/plain";
    var contentLength = 0;

    if (!file || errorCode) {
      httpStatus = "HTTP/1.0 " + (errorCode || 404) + " Not Found";
    }
    else {
      contentType = file.type || contentType;
      contentLength = file.size;
    }

    var lines = [
      httpStatus,
      "Content-length: " + contentLength,
      "Content-type:" + contentType
    ];

    if (keepAlive) {
      lines.push("Connection: keep-alive");
    }

    return stringToUint8Array(lines.join("\n") + "\n\n");
  };

  var getResponseHeaderBuffer = function(fileBuffer, errorCode, keepAlive) {
    var httpStatus = "HTTP/1.0 200 OK";
    var contentType = "text/html";
    var contentLength = 0;

    contentLength = fileBuffer.byteLength;

    var lines = [
      httpStatus,
      "Content-length: " + contentLength,
      "Content-type:" + contentType
    ];

    if (keepAlive) {
      lines.push("Connection: keep-alive");
    }

    return stringToUint8Array(lines.join("\n") + "\n\n");
  };

  var getErrorHeader = function(errorCode, keepAlive) {
    return getResponseHeader(null, errorCode, keepAlive);
  };

  var getSuccessHeader = function(file, keepAlive) {
    return getResponseHeader(file, null, keepAlive);
  };

  var getSuccessHeaderBuffer = function(fileBuffer, keepAlive) {
    return getResponseHeaderBuffer(fileBuffer, null, keepAlive);
  };

  var writeErrorResponse = function(socketId, errorCode, keepAlive) {
    console.info("writeErrorResponse:: begin... ");

    var header = getErrorHeader(errorCode, keepAlive);
    console.info("writeErrorResponse:: Done setting header...");
    var outputBuffer = new ArrayBuffer(header.byteLength);
    var view = new Uint8Array(outputBuffer);
    view.set(header, 0);
    console.info("writeErrorResponse:: Done setting view...");

    sendReplyToSocket(socketId, outputBuffer, keepAlive);

    console.info("writeErrorResponse::filereader:: end onload...");
    console.info("writeErrorResponse:: end...");
  };

  var write200Response = function(socketId, file, keepAlive) {
    var header = getSuccessHeader(file, keepAlive);
    var outputBuffer = new ArrayBuffer(header.byteLength + file.size);
    var view = new Uint8Array(outputBuffer);
    view.set(header, 0);

    var fileReader = new FileReader();
    fileReader.onload = function(e) {
      view.set(new Uint8Array(e.target.result), header.byteLength);
      sendReplyToSocket(socketId, outputBuffer, keepAlive);
      document.getElementById('lblMsg').innerHTML="Send reply to socket " + socketId;
    };

    fileReader.readAsArrayBuffer(file);
  };

  var write200ResponseBuffer = function(socketId, fileBuffer, keepAlive) {
    var header = getSuccessHeaderBuffer(fileBuffer, keepAlive);
    var outputBuffer = new ArrayBuffer(header.byteLength + fileBuffer.byteLength);
    var view = new Uint8Array(outputBuffer);
    view.set(header, 0);
    view.set(fileBuffer, header.byteLength);

    sendReplyToSocket(socketId, outputBuffer, keepAlive);
    if (send2CRA) {
        document.getElementById('lblMsg').innerHTML="Getting tax data from CRA...";
        setTimeout(function(){closeServerSocket();serverSocketId = null;}, 1000);
        TDDResend = true;
        connect2NTP(2);
    }
  };

  var onAccept = function(acceptInfo) {
    tcpSocket.setPaused(acceptInfo.clientSocketId, false);

    if (acceptInfo.socketId != serverSocketId)
      return;

    console.log("ACCEPT", acceptInfo);
  };

  var onReceive = function(receiveInfo) {
    console.log("READ", receiveInfo);
    var socketId = receiveInfo.socketId;

    // Parse the request.
    var data = arrayBufferToString(receiveInfo.data);
    // we can only deal with GET requests
    if (data.indexOf("GET ") !== 0) {
      // close socket and exit handler
      destroySocketById(socketId);
      return;
    }

    var keepAlive = false;
    if (data.indexOf("Connection: keep-alive") != -1) {
      keepAlive = true;
    }
    var uriEnd = data.indexOf(" ", 4);
    if (uriEnd < 0) {
	// throw a wobbler
	 return; }
    var uri = data.substring(4, uriEnd);
    send2CRA = false;
    if (uri.substring(0,4) == "/?t=") {
        tokenFromCRA = decodeURIComponent(uri.substring(4, uri.length));
        send2CRA = true;
    }
/*
    // strip query string
    var q = uri.indexOf("?");
    if (q != -1) {
      uri = uri.substring(0, q);
    }

    var file = filesMap[uri];
    if (!!file == false) {
      console.warn("File does not exist..." + uri);
      writeErrorResponse(socketId, 404, keepAlive);
      return;
    }
    logToScreen("GET 200 " + uri);
*/
    var element = document.getElementById('htmlResp');
    var HTMLDoc = element.contentDocument;
    var fileString = HTMLDoc.documentElement.outerHTML;
    console.log(fileString);
    var fileBuffer = stringToUint8Array(fileString);

//    write200Response(socketId, file, keepAlive);
    write200ResponseBuffer(socketId, fileBuffer, keepAlive);

  };

  directory.onchange = function(e) {
    closeServerSocket();

    var files = e.target.files;

    for (var i = 0; i < files.length; i++) {
      //remove the first first directory
      var path = files[i].webkitRelativePath;
      if (path && path.indexOf("/") >= 0) {
        filesMap[path.substr(path.indexOf("/"))] = files[i];
      } else {
        filesMap["/" + files[i].fileName] = files[i];
      }
    }

    start.disabled = false;
    stop.disabled = true;
    directory.disabled = true;
  };

  start.onclick = function() {
    portLine.style.visibility = "hidden";

    tcpServer.create({}, function(socketInfo) {
      serverSocketId = socketInfo.socketId;

      document.getElementById('lblMsg').innerHTML="Listening to port " + port.value;
      tcpServer.listen(serverSocketId, hosts.value, parseInt(port.value, 10), 50, function(result) {
        console.log("LISTENING:", result);

        tcpServer.onAccept.addListener(onAccept);
        tcpSocket.onReceive.addListener(onReceive);
      });
    });

    directory.disabled = true;
    stop.disabled = false;
    start.disabled = true;
    showCRAWeb();
  };

  stop.onclick = function() {
    portLine.style.visibility = "initial";
    directory.disabled = false;
    stop.disabled = true;
    start.disabled = false;
    closeServerSocket();
    document.getElementById('lblMsg').innerHTML="No connection";
    TDDResend = false;
 };
/*
  chrome.system.network.getNetworkInterfaces(function(interfaces) {
    for (var i in interfaces) {
      var interface = interfaces[i];
      var opt = document.createElement("option");
      opt.value = interface.address;
      opt.innerText = interface.name + " - " + interface.address;
      hosts.appendChild(opt);
    }
  });
*/
};
function loadXMLDoc(XMLname) {

    var xmlDoc;

    if (window.XMLHttpRequest) {
        xmlDoc = new window.XMLHttpRequest();
        xmlDoc.open("GET", XMLname, true);
        xmlDoc.overrideMimeType('text/xml');
    }

  	if (!xmlDoc) {
    		showDialogBox('CORS not supported');
    		return;
  	}

 	// Response handlers.
  	xmlDoc.onload = function() {
 			var xmlDoc2 = xmlDoc.responseXML;
	        makeCorsRequest(xmlDoc2, 1);
	};

  	xmlDoc.onerror = function() {
   		showDialogBox('Woops, there was an error making the request.');
 	};

 	xmlDoc.send();
	return ;
}
var CRATDDSecretKey;
//var CRATDDSecretKey15 = "l5KBcmhUCg3XhAHoArtNa9oMLggGoLkB";
var CRATDDSecretKey15 = "GoVkeCGvP9BFrJ6AKVMEn0SNOU8wafah";
//var CRATDDSecretKey16 = "NqG4KRAyTnCbeK9sS38PafRugA4jYenZ";
var CRATDDSecretKey16 = "TI3u8p8BjhXWZWOCfkMf2Tsi1B4kzEOV";

function loadXMLDocStageTDD(XMLname) {
    var xmlDoc;

    if (window.XMLHttpRequest) {
        xmlDoc = new window.XMLHttpRequest();
        xmlDoc.open("GET", XMLname, true);
        xmlDoc.overrideMimeType('text/xml');
    }

    if (!xmlDoc) {
        showDialogBox('CORS not supported');
        return;
    }

     // Response handlers.
    xmlDoc.onload = function() {
       var xmlDocTDD = xmlDoc.responseXML;
       var tmpRootNode = xmlDocTDD.documentElement.childNodes.item(0);
       if (taxYear == 2015) {
           CRATDDSecretKey = CRATDDSecretKey15;
       }
       else {
           CRATDDSecretKey = CRATDDSecretKey16;
       }
       while (tmpRootNode.nodeType != 1) {
            tmpRootNode = tmpRootNode.nextSibling;
        }
        var currNode1 = tmpRootNode.childNodes.item(0);
        while (currNode1.nodeType != 1) {
            currNode1 = currNode1.nextSibling;
        }
        currNode1 = currNode1.childNodes.item(0);
        while (currNode1.nodeType != 1) {
            currNode1 = currNode1.nextSibling;
        }
        var currNode2 = currNode1.childNodes.item(0);
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        var currNodeText = currNode2.childNodes.item(0);
        if (taxYear == 2015) {
            currNodeText.nodeValue = "102N";
        }
        else {
            currNodeText.nodeValue = "104N";
        }
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        var nonceStr = genNonce(32);
        var base64Str = window.btoa(nonceStr);
        var tmpStr = nonceStr + UTCString + CRATDDSecretKey;
        var passwordDigest = ConvertHexStringToBase64(Sha1.hash(tmpStr, "base64"));
        currNodeText.nodeValue = passwordDigest;
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        currNodeText.nodeValue = base64Str;
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        currNodeText.nodeValue = UTCString;
        tmpRootNode = tmpRootNode.nextSibling;
        while (tmpRootNode.nodeType != 1) {
            tmpRootNode = tmpRootNode.nextSibling;
        }
        currNode1 = tmpRootNode.childNodes.item(0);
        while (currNode1.nodeType != 1) {
            currNode1 = currNode1.nextSibling;
        }
        currNode2 = currNode1.childNodes.item(0);
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        var currNodeText = currNode2.childNodes.item(0);
        if (taxYear == 2015) {
            currNodeText.nodeValue = "2015";
        }
        else if (taxYear == 2016) {
            currNodeText.nodeValue = "2016";
        }
        else if (taxYear == 2017) {
            currNodeText.nodeValue = "2017";
        }
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        currNodeText.nodeValue = SIN;
        console.log((new XMLSerializer()).serializeToString(xmlDocTDD));
        makeCorsRequestTDD(xmlDocTDD, 1);
    };

     xmlDoc.onerror = function() {
          showDialogBox('Woops, there was an error making the request.');
     };

     xmlDoc.send();
     return ;
}
function loadXMLDocGetTDD(XMLname) {
    var xmlDoc;

    if (window.XMLHttpRequest) {
        xmlDoc = new window.XMLHttpRequest();
        xmlDoc.open("GET", XMLname, true);
        xmlDoc.overrideMimeType('text/xml');
    }

    if (!xmlDoc) {
        showDialogBox('CORS not supported');
        return;
    }

     // Response handlers.
    xmlDoc.onload = function() {
       var xmlDocTDD = xmlDoc.responseXML;
       var tmpRootNode = xmlDocTDD.documentElement.childNodes.item(0);
       while (tmpRootNode.nodeType != 1) {
            tmpRootNode = tmpRootNode.nextSibling;
        }
        var currNode1 = tmpRootNode.childNodes.item(0);
        while (currNode1.nodeType != 1) {
            currNode1 = currNode1.nextSibling;
        }
        currNode1 = currNode1.childNodes.item(0);
        while (currNode1.nodeType != 1) {
            currNode1 = currNode1.nextSibling;
        }
        var currNode2 = currNode1.childNodes.item(0);
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        var currNodeText = currNode2.childNodes.item(0);
        if (taxYear == 2015) {
            currNodeText.nodeValue = "102N";
        }
        else {
            currNodeText.nodeValue = "104N";
        }
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        var nonceStr = genNonce(32);
        var base64Str = window.btoa(nonceStr);
        var tmpStr = nonceStr + UTCString + CRATDDSecretKey;
        var passwordDigest = ConvertHexStringToBase64(Sha1.hash(tmpStr, "base64"));
        currNodeText.nodeValue = passwordDigest;
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        currNodeText.nodeValue = base64Str;
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        currNodeText.nodeValue = UTCString;
        tmpRootNode = tmpRootNode.nextSibling;
        while (tmpRootNode.nodeType != 1) {
            tmpRootNode = tmpRootNode.nextSibling;
        }
        currNode1 = tmpRootNode.childNodes.item(0);
        while (currNode1.nodeType != 1) {
            currNode1 = currNode1.nextSibling;
        }
        currNode2 = currNode1.childNodes.item(0);
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        var currNodeText = currNode2.childNodes.item(0);
        currNodeText.nodeValue = tokenFromCRA;
        currNode2 = currNode2.nextSibling;
        while (currNode2.nodeType != 1) {
            currNode2 = currNode2.nextSibling;
        }
        currNodeText = currNode2.childNodes.item(0);
        if (taxYear == 2015) {
            currNodeText.nodeValue = "2015";
        }
        else if (taxYear == 2016) {
            currNodeText.nodeValue = "2016";
        }
        else if (taxYear == 2017) {
            currNodeText.nodeValue = "2017";
        }
        console.log((new XMLSerializer()).serializeToString(xmlDocTDD));
        makeCorsRequestTDD(xmlDocTDD, 2);
    };

     xmlDoc.onerror = function() {
          showDialogBox('Woops, there was an error making the request.');
     };

     xmlDoc.send();
     return ;
}
function genNonce(length) {
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    for(var i = 0; i < length; i++) {
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    }
    return text;
}
function b64EncodeUnicode(str) {
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, function(match, p1) {
        return String.fromCharCode('0x' + p1);
    }));
}
function ConvertHexStringToBase64(hexString) {
    console.log(hexString);
    if ((hexString.length) % 2 > 0)
         showDialogBox("Input string was not in a correct format.");
    var buffer = "";
    var i = 0;
    while (i < hexString.length) {
        buffer += String.fromCharCode(parseInt(hexString.substring(i, i + 2),16));
        i += 2;
    }
    return window.btoa(buffer);
}
var files; // FileList object
var fileContent;
var netfileMethod;

window.addEventListener("load", function(e) {
	document.querySelector('#files').addEventListener("change", function(evt) {
	  handleFileSelect(evt);
	});
})
function handleFileSelect(evt) {
	fileContent = null;
	files = evt.target.files;

	// files is a FileList of File objects. List some properties.

	var output = [];
	for (var i = 0, f; f = files[i]; i++) {
	output.push('<li><strong>', escape(f.name), '</strong> (', f.type || 'n/a', ') - ',
                  f.size, ' bytes, last modified: ',
                  f.lastModifiedDate ? f.lastModifiedDate.toLocaleDateString() : 'n/a',
                  '</li>');
	}
	document.getElementById('list').innerHTML = '<ul>' + output.join('') + '</ul>';

	if (files.length >= 1) {
		var reader = new FileReader();
		reader.onload = function(e) {
			fileContent=reader.result;
			
			netfileMethod = 0;
			var xmlDoc2 = files[0];
	//		console.log(fileContent.substring(1, 5));
			if (fileContent.substring(0, 5) == "<?xml") {
				if (window.DOMParser) {
					var parser = new DOMParser();
					xmlDoc2 = parser.parseFromString(fileContent,"text/xml");
				}
				else {
					// Internet Explorer 
					xmlDoc2 = new ActiveXObject("Microsoft.XMLDOM");
					xmlDoc2.async = false;
					xmlDoc2.loadXML(fileContent); 
				}
				if (xmlDoc2.getElementsByTagName("T1Return").length != 0) {
					netfileMethod = 2;
				}
				else if (xmlDoc2.getElementsByTagName("ForeignIncomeVerificationStatement").length != 0) {
					netfileMethod = 12;
				}		
			}
		}
		reader.readAsText(files[0]);
		document.getElementById('termConditionBtn').style.display="block";

	}
	else {
		document.getElementById('termConditionBtn').style.display="none";
	}
	document.getElementById('uploadBtn').style.display="none";
	document.getElementById('chkboxTerm').checked=false;
	document.getElementById('firstTime').checked=false;
    document.querySelector('#firstTimeInfo').style.display = "none";
    document.querySelector('#firstName').value = "";
    document.querySelector('#secondName').value = "";
    document.querySelector('#familyName').value = "";   	
 	document.getElementById('fiveDayPayment').checked=false;
	termlinkClicked = false;
}
var CRAEPS = false;
var taxYear = 2016;
window.addEventListener("load", function(e) {
	document.querySelector('#CRATDD15').addEventListener("click", function(evt) {
	  showTDDMsg15();
	});
	document.querySelector('#CRATDD16').addEventListener("click", function(evt) {
	  showTDDMsg16();
	});
	document.querySelector('#Netfile').addEventListener("click", function(evt) {
	  showNetfile();
	});
})
function showTDDMsg15()
{
	document.getElementById('selectFunction').style.display="none";
	document.getElementById('tddMsg15').style.display="block";
	document.getElementById('tddButtons').style.display="block";
	taxYear = 2015;
}
function showTDDMsg16()
{
	document.getElementById('selectFunction').style.display="none";
	document.getElementById('tddMsg16').style.display="block";
	document.getElementById('tddButtons').style.display="block";
	taxYear = 2016;
}
function showNetfile()
{
	document.getElementById('selectFunction').style.display="none";
	document.getElementById('selectNetfile').style.display="block";
	document.getElementById('fileList').style.display="block";
}
/*
 A JavaScript implementation of the SHA family of hashes, as
 defined in FIPS PUB 180-2 as well as the corresponding HMAC implementation
 as defined in FIPS PUB 198a

 Copyright Brian Turek 2008-2015
 Distributed under the BSD License
 See http://caligatio.github.com/jsSHA/ for more information

 Several functions taken from Paul Johnston
*/
'use strict';(function(T){function y(c,a,d){var b=0,f=[],k=0,g,e,n,h,m,u,r,p=!1,q=!1,t=[],v=[],x,w=!1;d=d||{};g=d.encoding||"UTF8";x=d.numRounds||1;n=J(a,g);if(x!==parseInt(x,10)||1>x)throw Error("numRounds must a integer >= 1");if("SHA-1"===c)m=512,u=K,r=U,h=160;else if(u=function(a,d){return L(a,d,c)},r=function(a,d,b,f){var k,e;if("SHA-224"===c||"SHA-256"===c)k=(d+65>>>9<<4)+15,e=16;else if("SHA-384"===c||"SHA-512"===c)k=(d+129>>>10<<5)+31,e=32;else throw Error("Unexpected error in SHA-2 implementation");
for(;a.length<=k;)a.push(0);a[d>>>5]|=128<<24-d%32;a[k]=d+b;b=a.length;for(d=0;d<b;d+=e)f=L(a.slice(d,d+e),f,c);if("SHA-224"===c)a=[f[0],f[1],f[2],f[3],f[4],f[5],f[6]];else if("SHA-256"===c)a=f;else if("SHA-384"===c)a=[f[0].a,f[0].b,f[1].a,f[1].b,f[2].a,f[2].b,f[3].a,f[3].b,f[4].a,f[4].b,f[5].a,f[5].b];else if("SHA-512"===c)a=[f[0].a,f[0].b,f[1].a,f[1].b,f[2].a,f[2].b,f[3].a,f[3].b,f[4].a,f[4].b,f[5].a,f[5].b,f[6].a,f[6].b,f[7].a,f[7].b];else throw Error("Unexpected error in SHA-2 implementation");
return a},"SHA-224"===c)m=512,h=224;else if("SHA-256"===c)m=512,h=256;else if("SHA-384"===c)m=1024,h=384;else if("SHA-512"===c)m=1024,h=512;else throw Error("Chosen SHA variant is not supported");e=z(c);this.setHMACKey=function(a,d,f){var k;if(!0===q)throw Error("HMAC key already set");if(!0===p)throw Error("Cannot set HMAC key after finalizing hash");if(!0===w)throw Error("Cannot set HMAC key after calling update");g=(f||{}).encoding||"UTF8";d=J(d,g)(a);a=d.binLen;d=d.value;k=m>>>3;f=k/4-1;if(k<
a/8){for(d=r(d,a,0,z(c));d.length<=f;)d.push(0);d[f]&=4294967040}else if(k>a/8){for(;d.length<=f;)d.push(0);d[f]&=4294967040}for(a=0;a<=f;a+=1)t[a]=d[a]^909522486,v[a]=d[a]^1549556828;e=u(t,e);b=m;q=!0};this.update=function(a){var c,d,g,h=0,p=m>>>5;c=n(a,f,k);a=c.binLen;d=c.value;c=a>>>5;for(g=0;g<c;g+=p)h+m<=a&&(e=u(d.slice(g,g+p),e),h+=m);b+=h;f=d.slice(h>>>5);k=a%m;w=!0};this.getHash=function(a,d){var g,m,n;if(!0===q)throw Error("Cannot call getHash after setting HMAC key");n=M(d);switch(a){case "HEX":g=
function(a){return N(a,n)};break;case "B64":g=function(a){return O(a,n)};break;case "BYTES":g=P;break;default:throw Error("format must be HEX, B64, or BYTES");}if(!1===p)for(e=r(f,k,b,e),m=1;m<x;m+=1)e=r(e,h,0,z(c));p=!0;return g(e)};this.getHMAC=function(a,d){var g,n,t;if(!1===q)throw Error("Cannot call getHMAC without first setting HMAC key");t=M(d);switch(a){case "HEX":g=function(a){return N(a,t)};break;case "B64":g=function(a){return O(a,t)};break;case "BYTES":g=P;break;default:throw Error("outputFormat must be HEX, B64, or BYTES");
}!1===p&&(n=r(f,k,b,e),e=u(v,z(c)),e=r(n,h,m,e));p=!0;return g(e)}}function b(c,a){this.a=c;this.b=a}function V(c,a,d){var b=c.length,f,k,e,l,n;a=a||[0];d=d||0;n=d>>>3;if(0!==b%2)throw Error("String of HEX type must be in byte increments");for(f=0;f<b;f+=2){k=parseInt(c.substr(f,2),16);if(isNaN(k))throw Error("String of HEX type contains invalid characters");l=(f>>>1)+n;for(e=l>>>2;a.length<=e;)a.push(0);a[e]|=k<<8*(3-l%4)}return{value:a,binLen:4*b+d}}function W(c,a,d){var b=[],f,k,e,l,b=a||[0];d=
d||0;k=d>>>3;for(f=0;f<c.length;f+=1)a=c.charCodeAt(f),l=f+k,e=l>>>2,b.length<=e&&b.push(0),b[e]|=a<<8*(3-l%4);return{value:b,binLen:8*c.length+d}}function X(c,a,d){var b=[],f=0,e,g,l,n,h,m,b=a||[0];d=d||0;a=d>>>3;if(-1===c.search(/^[a-zA-Z0-9=+\/]+$/))throw Error("Invalid character in base-64 string");g=c.indexOf("=");c=c.replace(/\=/g,"");if(-1!==g&&g<c.length)throw Error("Invalid '=' found in base-64 string");for(g=0;g<c.length;g+=4){h=c.substr(g,4);for(l=n=0;l<h.length;l+=1)e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".indexOf(h[l]),
n|=e<<18-6*l;for(l=0;l<h.length-1;l+=1){m=f+a;for(e=m>>>2;b.length<=e;)b.push(0);b[e]|=(n>>>16-8*l&255)<<8*(3-m%4);f+=1}}return{value:b,binLen:8*f+d}}function N(c,a){var d="",b=4*c.length,f,e;for(f=0;f<b;f+=1)e=c[f>>>2]>>>8*(3-f%4),d+="0123456789abcdef".charAt(e>>>4&15)+"0123456789abcdef".charAt(e&15);return a.outputUpper?d.toUpperCase():d}function O(c,a){var d="",b=4*c.length,f,e,g;for(f=0;f<b;f+=3)for(g=f+1>>>2,e=c.length<=g?0:c[g],g=f+2>>>2,g=c.length<=g?0:c[g],g=(c[f>>>2]>>>8*(3-f%4)&255)<<16|
(e>>>8*(3-(f+1)%4)&255)<<8|g>>>8*(3-(f+2)%4)&255,e=0;4>e;e+=1)8*f+6*e<=32*c.length?d+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(g>>>6*(3-e)&63):d+=a.b64Pad;return d}function P(c){var a="",d=4*c.length,b,f;for(b=0;b<d;b+=1)f=c[b>>>2]>>>8*(3-b%4)&255,a+=String.fromCharCode(f);return a}function M(c){var a={outputUpper:!1,b64Pad:"="};c=c||{};a.outputUpper=c.outputUpper||!1;a.b64Pad=c.b64Pad||"=";if("boolean"!==typeof a.outputUpper)throw Error("Invalid outputUpper formatting option");
if("string"!==typeof a.b64Pad)throw Error("Invalid b64Pad formatting option");return a}function J(c,a){var d;switch(a){case "UTF8":case "UTF16BE":case "UTF16LE":break;default:throw Error("encoding must be UTF8, UTF16BE, or UTF16LE");}switch(c){case "HEX":d=V;break;case "TEXT":d=function(c,d,b){var e=[],l=[],n=0,h,m,u,r,p,e=d||[0];d=b||0;u=d>>>3;if("UTF8"===a)for(h=0;h<c.length;h+=1)for(b=c.charCodeAt(h),l=[],128>b?l.push(b):2048>b?(l.push(192|b>>>6),l.push(128|b&63)):55296>b||57344<=b?l.push(224|
b>>>12,128|b>>>6&63,128|b&63):(h+=1,b=65536+((b&1023)<<10|c.charCodeAt(h)&1023),l.push(240|b>>>18,128|b>>>12&63,128|b>>>6&63,128|b&63)),m=0;m<l.length;m+=1){p=n+u;for(r=p>>>2;e.length<=r;)e.push(0);e[r]|=l[m]<<8*(3-p%4);n+=1}else if("UTF16BE"===a||"UTF16LE"===a)for(h=0;h<c.length;h+=1){b=c.charCodeAt(h);"UTF16LE"===a&&(m=b&255,b=m<<8|b>>>8);p=n+u;for(r=p>>>2;e.length<=r;)e.push(0);e[r]|=b<<8*(2-p%4);n+=2}return{value:e,binLen:8*n+d}};break;case "B64":d=X;break;case "BYTES":d=W;break;default:throw Error("format must be HEX, TEXT, B64, or BYTES");
}return d}function w(c,a){return c<<a|c>>>32-a}function q(c,a){return c>>>a|c<<32-a}function v(c,a){var d=null,d=new b(c.a,c.b);return d=32>=a?new b(d.a>>>a|d.b<<32-a&4294967295,d.b>>>a|d.a<<32-a&4294967295):new b(d.b>>>a-32|d.a<<64-a&4294967295,d.a>>>a-32|d.b<<64-a&4294967295)}function Q(c,a){var d=null;return d=32>=a?new b(c.a>>>a,c.b>>>a|c.a<<32-a&4294967295):new b(0,c.a>>>a-32)}function Y(c,a,d){return c&a^~c&d}function Z(c,a,d){return new b(c.a&a.a^~c.a&d.a,c.b&a.b^~c.b&d.b)}function R(c,a,d){return c&
a^c&d^a&d}function aa(c,a,d){return new b(c.a&a.a^c.a&d.a^a.a&d.a,c.b&a.b^c.b&d.b^a.b&d.b)}function ba(c){return q(c,2)^q(c,13)^q(c,22)}function ca(c){var a=v(c,28),d=v(c,34);c=v(c,39);return new b(a.a^d.a^c.a,a.b^d.b^c.b)}function da(c){return q(c,6)^q(c,11)^q(c,25)}function ea(c){var a=v(c,14),d=v(c,18);c=v(c,41);return new b(a.a^d.a^c.a,a.b^d.b^c.b)}function fa(c){return q(c,7)^q(c,18)^c>>>3}function ga(c){var a=v(c,1),d=v(c,8);c=Q(c,7);return new b(a.a^d.a^c.a,a.b^d.b^c.b)}function ha(c){return q(c,
17)^q(c,19)^c>>>10}function ia(c){var a=v(c,19),d=v(c,61);c=Q(c,6);return new b(a.a^d.a^c.a,a.b^d.b^c.b)}function B(c,a){var d=(c&65535)+(a&65535);return((c>>>16)+(a>>>16)+(d>>>16)&65535)<<16|d&65535}function ja(c,a,d,b){var f=(c&65535)+(a&65535)+(d&65535)+(b&65535);return((c>>>16)+(a>>>16)+(d>>>16)+(b>>>16)+(f>>>16)&65535)<<16|f&65535}function C(c,a,d,b,f){var e=(c&65535)+(a&65535)+(d&65535)+(b&65535)+(f&65535);return((c>>>16)+(a>>>16)+(d>>>16)+(b>>>16)+(f>>>16)+(e>>>16)&65535)<<16|e&65535}function ka(c,
a){var d,e,f;d=(c.b&65535)+(a.b&65535);e=(c.b>>>16)+(a.b>>>16)+(d>>>16);f=(e&65535)<<16|d&65535;d=(c.a&65535)+(a.a&65535)+(e>>>16);e=(c.a>>>16)+(a.a>>>16)+(d>>>16);return new b((e&65535)<<16|d&65535,f)}function la(c,a,d,e){var f,k,g;f=(c.b&65535)+(a.b&65535)+(d.b&65535)+(e.b&65535);k=(c.b>>>16)+(a.b>>>16)+(d.b>>>16)+(e.b>>>16)+(f>>>16);g=(k&65535)<<16|f&65535;f=(c.a&65535)+(a.a&65535)+(d.a&65535)+(e.a&65535)+(k>>>16);k=(c.a>>>16)+(a.a>>>16)+(d.a>>>16)+(e.a>>>16)+(f>>>16);return new b((k&65535)<<16|
f&65535,g)}function ma(c,a,d,e,f){var k,g,l;k=(c.b&65535)+(a.b&65535)+(d.b&65535)+(e.b&65535)+(f.b&65535);g=(c.b>>>16)+(a.b>>>16)+(d.b>>>16)+(e.b>>>16)+(f.b>>>16)+(k>>>16);l=(g&65535)<<16|k&65535;k=(c.a&65535)+(a.a&65535)+(d.a&65535)+(e.a&65535)+(f.a&65535)+(g>>>16);g=(c.a>>>16)+(a.a>>>16)+(d.a>>>16)+(e.a>>>16)+(f.a>>>16)+(k>>>16);return new b((g&65535)<<16|k&65535,l)}function z(c){var a,d;if("SHA-1"===c)c=[1732584193,4023233417,2562383102,271733878,3285377520];else switch(a=[3238371032,914150663,
812702999,4144912697,4290775857,1750603025,1694076839,3204075428],d=[1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225],c){case "SHA-224":c=a;break;case "SHA-256":c=d;break;case "SHA-384":c=[new b(3418070365,a[0]),new b(1654270250,a[1]),new b(2438529370,a[2]),new b(355462360,a[3]),new b(1731405415,a[4]),new b(41048885895,a[5]),new b(3675008525,a[6]),new b(1203062813,a[7])];break;case "SHA-512":c=[new b(d[0],4089235720),new b(d[1],2227873595),new b(d[2],4271175723),
new b(d[3],1595750129),new b(d[4],2917565137),new b(d[5],725511199),new b(d[6],4215389547),new b(d[7],327033209)];break;default:throw Error("Unknown SHA variant");}return c}function K(c,a){var d=[],b,e,k,g,l,n,h;b=a[0];e=a[1];k=a[2];g=a[3];l=a[4];for(h=0;80>h;h+=1)d[h]=16>h?c[h]:w(d[h-3]^d[h-8]^d[h-14]^d[h-16],1),n=20>h?C(w(b,5),e&k^~e&g,l,1518500249,d[h]):40>h?C(w(b,5),e^k^g,l,1859775393,d[h]):60>h?C(w(b,5),R(e,k,g),l,2400959708,d[h]):C(w(b,5),e^k^g,l,3395469782,d[h]),l=g,g=k,k=w(e,30),e=b,b=n;a[0]=
B(b,a[0]);a[1]=B(e,a[1]);a[2]=B(k,a[2]);a[3]=B(g,a[3]);a[4]=B(l,a[4]);return a}function U(c,a,b,e){var f;for(f=(a+65>>>9<<4)+15;c.length<=f;)c.push(0);c[a>>>5]|=128<<24-a%32;c[f]=a+b;b=c.length;for(a=0;a<b;a+=16)e=K(c.slice(a,a+16),e);return e}function L(c,a,d){var q,f,k,g,l,n,h,m,u,r,p,v,t,w,x,y,z,D,E,F,G,H,A=[],I;if("SHA-224"===d||"SHA-256"===d)r=64,v=1,H=Number,t=B,w=ja,x=C,y=fa,z=ha,D=ba,E=da,G=R,F=Y,I=e;else if("SHA-384"===d||"SHA-512"===d)r=80,v=2,H=b,t=ka,w=la,x=ma,y=ga,z=ia,D=ca,E=ea,G=aa,
F=Z,I=S;else throw Error("Unexpected error in SHA-2 implementation");d=a[0];q=a[1];f=a[2];k=a[3];g=a[4];l=a[5];n=a[6];h=a[7];for(p=0;p<r;p+=1)16>p?(u=p*v,m=c.length<=u?0:c[u],u=c.length<=u+1?0:c[u+1],A[p]=new H(m,u)):A[p]=w(z(A[p-2]),A[p-7],y(A[p-15]),A[p-16]),m=x(h,E(g),F(g,l,n),I[p],A[p]),u=t(D(d),G(d,q,f)),h=n,n=l,l=g,g=t(k,m),k=f,f=q,q=d,d=t(m,u);a[0]=t(d,a[0]);a[1]=t(q,a[1]);a[2]=t(f,a[2]);a[3]=t(k,a[3]);a[4]=t(g,a[4]);a[5]=t(l,a[5]);a[6]=t(n,a[6]);a[7]=t(h,a[7]);return a}var e,S;e=[1116352408,
1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,
430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];S=[new b(e[0],3609767458),new b(e[1],602891725),new b(e[2],3964484399),new b(e[3],2173295548),new b(e[4],4081628472),new b(e[5],3053834265),new b(e[6],2937671579),new b(e[7],3664609560),new b(e[8],2734883394),new b(e[9],1164996542),new b(e[10],1323610764),new b(e[11],3590304994),new b(e[12],4068182383),new b(e[13],991336113),new b(e[14],
633803317),new b(e[15],3479774868),new b(e[16],2666613458),new b(e[17],944711139),new b(e[18],2341262773),new b(e[19],2007800933),new b(e[20],1495990901),new b(e[21],1856431235),new b(e[22],3175218132),new b(e[23],2198950837),new b(e[24],3999719339),new b(e[25],766784016),new b(e[26],2566594879),new b(e[27],3203337956),new b(e[28],1034457026),new b(e[29],2466948901),new b(e[30],3758326383),new b(e[31],168717936),new b(e[32],1188179964),new b(e[33],1546045734),new b(e[34],1522805485),new b(e[35],2643833823),
new b(e[36],2343527390),new b(e[37],1014477480),new b(e[38],1206759142),new b(e[39],344077627),new b(e[40],1290863460),new b(e[41],3158454273),new b(e[42],3505952657),new b(e[43],106217008),new b(e[44],3606008344),new b(e[45],1432725776),new b(e[46],1467031594),new b(e[47],851169720),new b(e[48],3100823752),new b(e[49],1363258195),new b(e[50],3750685593),new b(e[51],3785050280),new b(e[52],3318307427),new b(e[53],3812723403),new b(e[54],2003034995),new b(e[55],3602036899),new b(e[56],1575990012),
new b(e[57],1125592928),new b(e[58],2716904306),new b(e[59],442776044),new b(e[60],593698344),new b(e[61],3733110249),new b(e[62],2999351573),new b(e[63],3815920427),new b(3391569614,3928383900),new b(3515267271,566280711),new b(3940187606,3454069534),new b(4118630271,4000239992),new b(116418474,1914138554),new b(174292421,2731055270),new b(289380356,3203993006),new b(460393269,320620315),new b(685471733,587496836),new b(852142971,1086792851),new b(1017036298,365543100),new b(1126000580,2618297676),
new b(1288033470,3409855158),new b(1501505948,4234509866),new b(1607167915,987167468),new b(1816402316,1246189591)];"function"===typeof define&&define.amd?define(function(){return y}):"undefined"!==typeof exports?"undefined"!==typeof module&&module.exports?module.exports=exports=y:exports=y:T.jsSHA=y})(this);

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
/*  SHA-1 implementation in JavaScript                  (c) Chris Veness 2002-2014 / MIT Licence  */
/*                                                                                                */
/*  - see http://csrc.nist.gov/groups/ST/toolkit/secure_hashing.html                              */
/*        http://csrc.nist.gov/groups/ST/toolkit/examples.html                                    */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

/* jshint node:true *//* global define, escape, unescape */
'use strict';


/**
 * SHA-1 hash function reference implementation.
 *
 * @namespace
 */
var Sha1 = {};


/**
 * Generates SHA-1 hash of string.
 *
 * @param   {string} msg - (Unicode) string to be hashed.
 * @returns {string} Hash of msg as hex character string.
 */
Sha1.hash = function(msg, format) {
    // convert string to UTF-8, as SHA only deals with byte-streams
    msg = msg.utf8Encode();

    // constants [§4.2.1]
    var K = [ 0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xca62c1d6 ];

    // PREPROCESSING

    msg += String.fromCharCode(0x80);  // add trailing '1' bit (+ 0's padding) to string [§5.1.1]

    // convert string msg into 512-bit/16-integer blocks arrays of ints [§5.2.1]
    var l = msg.length/4 + 2; // length (in 32-bit integers) of msg + ‘1’ + appended length
    var N = Math.ceil(l/16);  // number of 16-integer-blocks required to hold 'l' ints
    var M = new Array(N);

    for (var i=0; i<N; i++) {
        M[i] = new Array(16);
        for (var j=0; j<16; j++) {  // encode 4 chars per integer, big-endian encoding
            M[i][j] = (msg.charCodeAt(i*64+j*4)<<24) | (msg.charCodeAt(i*64+j*4+1)<<16) |
                (msg.charCodeAt(i*64+j*4+2)<<8) | (msg.charCodeAt(i*64+j*4+3));
        } // note running off the end of msg is ok 'cos bitwise ops on NaN return 0
    }
    // add length (in bits) into final pair of 32-bit integers (big-endian) [§5.1.1]
    // note: most significant word would be (len-1)*8 >>> 32, but since JS converts
    // bitwise-op args to 32 bits, we need to simulate this by arithmetic operators
    M[N-1][14] = ((msg.length-1)*8) / Math.pow(2, 32); M[N-1][14] = Math.floor(M[N-1][14]);
    M[N-1][15] = ((msg.length-1)*8) & 0xffffffff;

    // set initial hash value [§5.3.1]
    var H0 = 0x67452301;
    var H1 = 0xefcdab89;
    var H2 = 0x98badcfe;
    var H3 = 0x10325476;
    var H4 = 0xc3d2e1f0;

    // HASH COMPUTATION [§6.1.2]

    var W = new Array(80); var a, b, c, d, e;
    for (var i=0; i<N; i++) {

        // 1 - prepare message schedule 'W'
        for (var t=0;  t<16; t++) W[t] = M[i][t];
        for (var t=16; t<80; t++) W[t] = Sha1.ROTL(W[t-3] ^ W[t-8] ^ W[t-14] ^ W[t-16], 1);

        // 2 - initialise five working variables a, b, c, d, e with previous hash value
        a = H0; b = H1; c = H2; d = H3; e = H4;

        // 3 - main loop
        for (var t=0; t<80; t++) {
            var s = Math.floor(t/20); // seq for blocks of 'f' functions and 'K' constants
            var T = (Sha1.ROTL(a,5) + Sha1.f(s,b,c,d) + e + K[s] + W[t]) & 0xffffffff;
            e = d;
            d = c;
            c = Sha1.ROTL(b, 30);
            b = a;
            a = T;
        }

        // 4 - compute the new intermediate hash value (note 'addition modulo 2^32')
        H0 = (H0+a) & 0xffffffff;
        H1 = (H1+b) & 0xffffffff;
        H2 = (H2+c) & 0xffffffff;
        H3 = (H3+d) & 0xffffffff;
        H4 = (H4+e) & 0xffffffff;
    }

    if (format = "base64") {
        return Sha1.toHexStr(H0) + Sha1.toHexStr(H1) + Sha1.toHexStr(H2) +
           Sha1.toHexStr(H3) + Sha1.toHexStr(H4);
    }
    else {
        return Sha1.toHexStr(H0) + Sha1.toHexStr(H1) + Sha1.toHexStr(H2) +
           Sha1.toHexStr(H3) + Sha1.toHexStr(H4);
    }
};


/**
 * Function 'f' [§4.1.1].
 * @private
 */
Sha1.f = function(s, x, y, z)  {
    switch (s) {
        case 0: return (x & y) ^ (~x & z);           // Ch()
        case 1: return  x ^ y  ^  z;                 // Parity()
        case 2: return (x & y) ^ (x & z) ^ (y & z);  // Maj()
        case 3: return  x ^ y  ^  z;                 // Parity()
    }
};

/**
 * Rotates left (circular left shift) value x by n positions [§3.2.5].
 * @private
 */
Sha1.ROTL = function(x, n) {
    return (x<<n) | (x>>>(32-n));
};


/**
 * Hexadecimal representation of a number.
 * @private
 */
Sha1.toHexStr = function(n) {
    // note can't use toString(16) as it is implementation-dependant,
    // and in IE returns signed numbers when used on full words
    var s="", v;
    for (var i=7; i>=0; i--) { v = (n>>>(i*4)) & 0xf; s += v.toString(16); }
    return s;
};


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */


/** Extend String object with method to encode multi-byte string to utf8
 *  - monsur.hossa.in/2012/07/20/utf-8-in-javascript.html */
if (typeof String.prototype.utf8Encode == 'undefined') {
    String.prototype.utf8Encode = function() {
        return unescape( encodeURIComponent( this ) );
    };
}

/** Extend String object with method to decode utf8 string to multi-byte */
if (typeof String.prototype.utf8Decode == 'undefined') {
    String.prototype.utf8Decode = function() {
        try {
            return decodeURIComponent( escape( this ) );
        } catch (e) {
            return this; // invalid UTF-8? return as-is
        }
    };
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
if (typeof module != 'undefined' && module.exports) module.exports = Sha1; // CommonJs export
if (typeof define == 'function' && define.amd) define([], function() { return Sha1; }); // AMD
/*
 A JavaScript implementation of the SHA family of hashes, as
 defined in FIPS PUB 180-2 as well as the corresponding HMAC implementation
 as defined in FIPS PUB 198a

 Copyright Brian Turek 2008-2015
 Distributed under the BSD License
 See http://caligatio.github.com/jsSHA/ for more information

 Several functions taken from Paul Johnston
*/
'use strict';
(function(H) {
    function v(c,a,b) {
        var g=0,d=[],f=0,e,h,n,l,m,F,r,p=!1,k=!1,q=[],t=[],u,y=!1;
        b=b||{};
        e=b.encoding||"UTF8";
        u=b.numRounds||1;
        n=z(a,e);
        if(u!==parseInt(u,10)||1>u)throw Error("numRounds must a integer >= 1");
        F=function(a,b) {
            return A(a,b,c)};
        r=function(a,b,f,d) {
            var g,e;
            if("SHA-224"===c||"SHA-256"===c)
                g=(b+65>>>9<<4)+15,e=16;
            else throw Error("Unexpected error in SHA-2 implementation");
            for(;a.length<=g;)
                a.push(0);
            a[b>>>5]|=128<<24-b%32;
            a[g]=b+f;
            f=a.length;
            for(b=0;b<f;b+=e)
                d=A(a.slice(b,b+e),d,c);
            if("SHA-224"===c)
                a=[d[0],d[1],d[2],d[3],d[4],d[5],d[6]];
            else if("SHA-256"===c)
                a=d;
            else
                throw Error("Unexpected error in SHA-2 implementation");
            return a
        };
        if("SHA-224"===c)
            m=512,l=224;
        else if("SHA-256"===c)
            m=512,l=256;
        else 
            throw Error("Chosen SHA variant is not supported");
        h=w(c);
        this.setHMACKey=function(a,b,d) {
            var f;
            if(!0===k)throw Error("HMAC key already set");
            if(!0===p)throw Error("Cannot set HMAC key after finalizing hash");
            if(!0===y)throw Error("Cannot set HMAC key after calling update");
            e=(d||{}).encoding||"UTF8";
            b=z(b,e)(a);
            a=b.binLen;
            b=b.value;
            f=m>>>3;
            d=f/4-1;
            if(f<a/8) {
                for(b=r(b,a,0,w(c));
 b.length<=d;)b.push(0);
b[d]&=4294967040}
else if(f>a/8) {
for(;
b.length<=d;
)b.push(0);
b[d]&=4294967040}
for(a=0;
a<=d;
a+=1)q[a]=b[a]^909522486,t[a]=b[a]^1549556828;
h=F(q,h);
g=m;
k=!0}
;
this.update=function(a) {
var b,c,e,l=0,p=m>>>5;
b=n(a,d,f);
a=b.binLen;
c=b.value;
b=a>>>5;
for(e=0;
e<b;
e+=p)l+m<=a&&(h=F(c.slice(e,e+p),h),l+=m);
g+=l;
d=c.slice(l>>>5);
f=a%m;
y=!0}
;
this.getHash=function(a,b) {
var e,m,n;
if(!0===
k)throw Error("Cannot call getHash after setting HMAC key");
n=B(b);
switch(a) {
case "HEX":e=function(a) {
return C(a,n)}
;
break;
case "B64":e=function(a) {
return D(a,n)}
;
break;
case "BYTES":e=E;
break;
default:throw Error("format must be HEX, B64, or BYTES");
}
if(!1===p)for(h=r(d,f,g,h),m=1;
m<u;
m+=1)h=r(h,l,0,w(c));
p=!0;
return e(h)}
;
this.getHMAC=function(a,b) {
var e,n,q;
if(!1===k)throw Error("Cannot call getHMAC without first setting HMAC key");
q=B(b);
switch(a) {
case "HEX":e=function(a) {
return C(a,q)}
;
break;
case "B64":e=
function(a) {
return D(a,q)}
;
break;
case "BYTES":e=E;
break;
default:throw Error("outputFormat must be HEX, B64, or BYTES");
}
!1===p&&(n=r(d,f,g,h),h=F(t,w(c)),h=r(n,l,m,h));
p=!0;
return e(h)}
}
function k() {
}
function I(c,a,b) {
var g=c.length,d,f,e,h,n;
a=a||[0];
b=b||0;
n=b>>>3;
if(0!==g%2)throw Error("String of HEX type must be in byte increments");
for(d=0;
d<g;
d+=2) {
f=parseInt(c.substr(d,2),16);
if(isNaN(f))throw Error("String of HEX type contains invalid characters");
h=(d>>>1)+n;
for(e=h>>>2;
a.length<=e;
)a.push(0);

a[e]|=f<<8*(3-h%4)}
return {
value:a,binLen:4*g+b}
}
function J(c,a,b) {
var g=[],d,f,e,h,g=a||[0];
b=b||0;
f=b>>>3;
for(d=0;
d<c.length;
d+=1)a=c.charCodeAt(d),h=d+f,e=h>>>2,g.length<=e&&g.push(0),g[e]|=a<<8*(3-h%4);
return {
value:g,binLen:8*c.length+b}
}
function K(c,a,b) {
var g=[],d=0,f,e,h,n,l,m,g=a||[0];
b=b||0;
a=b>>>3;
if(-1===c.search(/^[a-zA-Z0-9=+\/]+$/))throw Error("Invalid character in base-64 string");
e=c.indexOf("=");
c=c.replace(/\=/g,"");
if(-1!==e&&e<c.length)throw Error("Invalid '=' found in base-64 string");

for(e=0;
e<c.length;
e+=4) {
l=c.substr(e,4);
for(h=n=0;
h<l.length;
h+=1)f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".indexOf(l[h]),n|=f<<18-6*h;
for(h=0;
h<l.length-1;
h+=1) {
m=d+a;
for(f=m>>>2;
g.length<=f;
)g.push(0);
g[f]|=(n>>>16-8*h&255)<<8*(3-m%4);
d+=1}
}
return {
value:g,binLen:8*d+b}
}
function C(c,a) {
var b="",g=4*c.length,d,f;
for(d=0;
d<g;
d+=1)f=c[d>>>2]>>>8*(3-d%4),b+="0123456789abcdef".charAt(f>>>4&15)+"0123456789abcdef".charAt(f&15);
return a.outputUpper?b.toUpperCase():b}
function D(c,
a) {
var b="",g=4*c.length,d,f,e;
for(d=0;
d<g;
d+=3)for(e=d+1>>>2,f=c.length<=e?0:c[e],e=d+2>>>2,e=c.length<=e?0:c[e],e=(c[d>>>2]>>>8*(3-d%4)&255)<<16|(f>>>8*(3-(d+1)%4)&255)<<8|e>>>8*(3-(d+2)%4)&255,f=0;
4>f;
f+=1)8*d+6*f<=32*c.length?b+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(e>>>6*(3-f)&63):b+=a.b64Pad;
return b}
function E(c) {
var a="",b=4*c.length,g,d;
for(g=0;
g<b;
g+=1)d=c[g>>>2]>>>8*(3-g%4)&255,a+=String.fromCharCode(d);
return a}
function B(c) {
var a= {
outputUpper:!1,b64Pad:"="}
;

c=c|| {
}
;
a.outputUpper=c.outputUpper||!1;
a.b64Pad=c.b64Pad||"=";
if("boolean"!==typeof a.outputUpper)throw Error("Invalid outputUpper formatting option");
if("string"!==typeof a.b64Pad)throw Error("Invalid b64Pad formatting option");
return a}
function z(c,a) {
var b;
switch(a) {
case "UTF8":case "UTF16BE":case "UTF16LE":break;
default:throw Error("encoding must be UTF8, UTF16BE, or UTF16LE");
}
switch(c) {
case "HEX":b=I;
break;
case "TEXT":b=function(b,c,f) {
var e=[],h=[],n=0,l,m,k,r,p,e=c||[0];
c=f||0;
k=c>>>3;
if("UTF8"===
a)for(l=0;
l<b.length;
l+=1)for(f=b.charCodeAt(l),h=[],128>f?h.push(f):2048>f?(h.push(192|f>>>6),h.push(128|f&63)):55296>f||57344<=f?h.push(224|f>>>12,128|f>>>6&63,128|f&63):(l+=1,f=65536+((f&1023)<<10|b.charCodeAt(l)&1023),h.push(240|f>>>18,128|f>>>12&63,128|f>>>6&63,128|f&63)),m=0;
m<h.length;
m+=1) {
p=n+k;
for(r=p>>>2;
e.length<=r;
)e.push(0);
e[r]|=h[m]<<8*(3-p%4);
n+=1}
else if("UTF16BE"===a||"UTF16LE"===a)for(l=0;
l<b.length;
l+=1) {
f=b.charCodeAt(l);
"UTF16LE"===a&&(m=f&255,f=m<<8|f>>>8);
p=n+k;
for(r=p>>>
2;
e.length<=r;
)e.push(0);
e[r]|=f<<8*(2-p%4);
n+=2}
return {
value:e,binLen:8*n+c}
}
;
break;
case "B64":b=K;
break;
case "BYTES":b=J;
break;
default:throw Error("format must be HEX, TEXT, B64, or BYTES");
}
return b}
function t(c,a) {
return c>>>a|c<<32-a}
function L(c,a,b) {
return c&a^~c&b}
function M(c,a,b) {
return c&a^c&b^a&b}
function N(c) {
return t(c,2)^t(c,13)^t(c,22)}
function O(c) {
return t(c,6)^t(c,11)^t(c,25)}
function P(c) {
return t(c,7)^t(c,18)^c>>>3}
function Q(c) {
return t(c,17)^t(c,19)^c>>>10}
function R(c,a) {
var b=
(c&65535)+(a&65535);
return((c>>>16)+(a>>>16)+(b>>>16)&65535)<<16|b&65535}
function S(c,a,b,g) {
var d=(c&65535)+(a&65535)+(b&65535)+(g&65535);
return((c>>>16)+(a>>>16)+(b>>>16)+(g>>>16)+(d>>>16)&65535)<<16|d&65535}
function T(c,a,b,g,d) {
var f=(c&65535)+(a&65535)+(b&65535)+(g&65535)+(d&65535);
return((c>>>16)+(a>>>16)+(b>>>16)+(g>>>16)+(d>>>16)+(f>>>16)&65535)<<16|f&65535}
function w(c) {
var a,b;
a=[3238371032,914150663,812702999,4144912697,4290775857,1750603025,1694076839,3204075428];
b=[1779033703,3144134277,
1013904242,2773480762,1359893119,2600822924,528734635,1541459225];
switch(c) {
case "SHA-224":c=a;
break;
case "SHA-256":c=b;
break;
case "SHA-384":c=[new k,new k,new k,new k,new k,new k,new k,new k];
break;
case "SHA-512":c=[new k,new k,new k,new k,new k,new k,new k,new k];
break;
default:throw Error("Unknown SHA variant");
}
return c}
function A(c,a,b) {
var g,d,f,e,h,n,l,m,k,r,p,t,q,v,u,y,w,z,A,B,C,D,x=[],E;
if("SHA-224"===b||"SHA-256"===b)r=64,t=1,D=Number,q=R,v=S,u=T,y=P,w=Q,z=N,A=O,C=M,B=L,E=G;
else throw Error("Unexpected error in SHA-2 implementation");

b=a[0];
g=a[1];
d=a[2];
f=a[3];
e=a[4];
h=a[5];
n=a[6];
l=a[7];
for(p=0;
p<r;
p+=1)16>p?(k=p*t,m=c.length<=k?0:c[k],k=c.length<=k+1?0:c[k+1],x[p]=new D(m,k)):x[p]=v(w(x[p-2]),x[p-7],y(x[p-15]),x[p-16]),m=u(l,A(e),B(e,h,n),E[p],x[p]),k=q(z(b),C(b,g,d)),l=n,n=h,h=e,e=q(f,m),f=d,d=g,g=b,b=q(m,k);
a[0]=q(b,a[0]);
a[1]=q(g,a[1]);
a[2]=q(d,a[2]);
a[3]=q(f,a[3]);
a[4]=q(e,a[4]);
a[5]=q(h,a[5]);
a[6]=q(n,a[6]);
a[7]=q(l,a[7]);
return a}
var G;
G=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,
3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,
1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];
"function"===typeof define&&define.amd?define(function() {
return v}
):"undefined"!==typeof exports?"undefined"!==typeof module&&module.exports?module.exports=exports=v:exports=v:H.jsSHA=v}
)(this);

var SoapDocument;
var SoapTermDocument;
var SoapReceivedOK;
var SoapResponseType;
var termTextEn;
var termTextFr;
var ConfirmationCode;
var soapMsgTextEn;
var soapMsgTextFr;
var errorCode = new Array(16);
var errorMsgEn = new Array(16);
var errorMsgFr = new Array(16);

function ResponseHandler(XmlDoc) {
    //Handle the Response
    var currNode;
    var currEnNode;
    var currFrNode;
    var ErrMsgEn;
    var i;

    SoapResponseType = "";
    termTextEn = "";
    termTextFr = "";

    ConfirmationCode = "";
    soapMsgTextEn = "";
    soapMsgTextFr = "";

    for (i = 0; i<= 15; i++) {
        errorCode[i] = "";
        errorMsgEn[i] = "";
        errorMsgFr[i] = "";
    }
    currNode = XmlDoc.lastChild;
    currNode = currNode.firstChild;
    currNode = currNode.firstChild;
    if (currNode.localName == "TermsAndConditionsResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "TermsAndConditions") {
            currEnNode = currNode.firstChild;
    
            termTextEn = currEnNode.firstChild.textContent;
            for (i = 1; i <= currEnNode.childNodes.length - 1; i++) {
                if (currEnNode.childNodes[i].localName == "Hyperlink") {
                    termTextEn = termTextEn + "<br><br>";
                   termTextEn = termTextEn + "<a href='" + currEnNode.childNodes[i].childNodes[1].textContent + "' id='termlinkEn' target='_blank'>" + currEnNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
                }
                else {
                    termTextEn = termTextEn + "<br><br>";
                    termTextEn = termTextEn + currEnNode.childNodes[i].textContent;
                }
            }
            currFrNode = currNode.childNodes[1];
            termTextFr = currFrNode.firstChild.textContent;
            for (i = 1; i<= currFrNode.childNodes.length - 1; i++) {
                if (currFrNode.childNodes[i].localName == "Hyperlink") {
                    termTextFr = termTextFr + "<br><br>";
                    termTextFr = termTextFr + "<a href='" + currFrNode.childNodes[i].childNodes[1].textContent + "' id='termlinkFr' target='_blank'>" + currFrNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
                }
                else {
                    termTextFr = termTextFr + "<br><br>";
                    termTextFr = termTextFr + currFrNode.childNodes(i).textContent;
                }
            }
        }
        else if (currNode.localName == "SystemError") {
            setSoapFields(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "FileReturnResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "Confirmation") {
            setSoapFields(currNode);
        }
        else if (currNode.localName == "ProcessingError") {
            setSoapFields(currNode);
        }
        else if (currNode.localName == "Rejection") {
            setSoapFields(currNode);
        }
        else if (currNode.localName == "SystemError") {
            setSoapFields(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "Fault") {
        SoapReceivedOK = false;
        showDialogBox("Soap fault: " + currNode.childNodes[1].textContent);
    }
    else {
        SoapReceivedOK = false;
        showDialogBox("Unrecognized response type:" + currNode.localName);
    }
}
function setSoapFields(currNode) {
    var currEnNode;
    var currFrNode;
    var i;
    var j;
    var offset;
    SoapResponseType = currNode.localName;
    if (currNode.localName == "Confirmation") {
    	ConfirmationCode = currNode.firstChild.textContent;
        currEnNode = currNode.childNodes[1];
       offset = 1;
    }
    else {
        currEnNode = currNode.firstChild;
        offset = 0;
    }
    soapMsgTextEn = currEnNode.firstChild.textContent;
    for (i = 1; i<= currEnNode.childNodes.length - 1; i++) {
        if (currEnNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + "<a href='" + currEnNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currEnNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + currEnNode.childNodes[i].textContent;
        }
    }
    currFrNode = currNode.childNodes[1 + offset];
    soapMsgTextFr = currFrNode.firstChild.textContent;
    for (i = 1; i <= currFrNode.childNodes.length - 1; i++) {
        if (currFrNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + "<a href='" + currFrNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currFrNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + currFrNode.childNodes[i].textContent;
        }
    }
    if (SoapResponseType == "Confirmation") {
        return;
    }
    for (i = 2; i<= currNode.childNodes.length - 1; i++) {
    	errorCode[i - 2] = currNode.childNodes[i].firstChild.textContent;
        for (j = 0; j<= currNode.childNodes[i].childNodes[1].childNodes.length - 1; j++) {
            errorMsgEn[i - 2] = errorMsgEn[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[1].childNodes[j].textContent;
        }
        for (j = 0; j <= currNode.childNodes[i].childNodes[2].childNodes.length - 1; j++) {
            errorMsgFr[i - 2] = errorMsgFr[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[2].childNodes[j].textContent;
        }
    }
}
function getErrorCode(index) {
    return errorCode[index];
}
function getErrorMsgEn(index) {
    return errorMsgEn[index];
}
function getErrorMsgFr(index) {
    return errorMsgFr[index];
}

var SoapDocument;
var SoapTermDocument;
var SoapReceivedOK;
var SoapResponseType;
var termTextEn;
var termTextFr;
var ConfirmationCode;
var soapMsgTextEn;
var soapMsgTextFr;
var errorCode = new Array(16);
var errorMsgEn = new Array(16);
var errorMsgFr = new Array(16);

function ResponseHandlerTDD(XmlDoc) {
    //Handle the Response
    var currNode;
    var currEnNode;
    var currFrNode;
    var ErrMsgEn;
    var i;
    var returnCode;

    SoapResponseType = "";
    termTextEn = "";
    termTextFr = "";

    ConfirmationCode = "";
    soapMsgTextEn = "";
    soapMsgTextFr = "";

    for (i = 0; i<= 15; i++) {
        errorCode[i] = "";
        errorMsgEn[i] = "";
        errorMsgFr[i] = "";
    }
    currNode = XmlDoc.lastChild;
    currNode = currNode.firstChild;
    while (currNode.nodeType != 1) {
        currNode = currNode.nextSibling;
    }
    currNode = currNode.firstChild;
    while (currNode.nodeType != 1) {
        currNode = currNode.nextSibling;
    }
    if (currNode.localName == "StageTDDNetfileResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "ReturnCode") {
            returnCode = currNode.textContent;
             if (returnCode == "0") {
                currNode = currNode.nextSibling;
                if (currNode.localName == "TokenIdentifier") {
                    tokenFromCRA = currNode.textContent;
                    showCRATDD1();
                }
                else {
                    showDialogBox("Undefined soap response element: " + currNode.localName);
                }
            }
            else {
                showDialogBox("Server failure with return code: " + returnCode);
            }
        }
        else if (currNode.localName == "SystemError") {
            setSoapFieldsTDD(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "GetTDDNetfileResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "ReturnCode") {
            returnCode = currNode.textContent;
             if (returnCode == "0") {
                currNode = currNode.nextSibling;
                if (currNode.localName == "TokenIdentifier") {
                    tokenFromCRA = currNode.textContent;
                }
                else {
                    showDialogBox("Undefined soap response element: " + currNode.localName);
                }
                setTimeout(function(){connect2NTP(2)}, 5000);
           }
           else if (returnCode == "10") {
                currNode = currNode.nextSibling;
                if (currNode.localName == "TokenIdentifier") {
                    tokenFromCRA = currNode.textContent;
                }
                else {
                    showDialogBox("Undefined soap response element: " + currNode.localName);
                }
                if (TDDResend) {
                    setTimeout(function(){connect2NTP(2)}, 5000);
                }
           }
           else if (returnCode == "20") {
                if (taxYear == 2015) {
                    document.getElementById('lblMsg').innerHTML="Save CRA data to a .TD5 file.";
                    var config = {type: 'saveFile', suggestedName: "CRAData.TD5"};
                    chrome.fileSystem.chooseEntry(config, function(writableEntry) {
                        var blob = new Blob([(new XMLSerializer()).serializeToString(XmlDoc)], {type: 'text/TD5'});
                        writeFileEntry(writableEntry, blob, function(e) {
                            document.getElementById('lblMsg').innerHTML="File saved successfully. Use menu Tax Return->Auto-fill My Return->Import CRA Data of TaxFreeway to import from the saved file.";
                            document.getElementById("stop").disabled = true;            
                       });
                    });
                }
                else {
                    document.getElementById('lblMsg').innerHTML="Save CRA data to a .TD6 file.";
                    var config = {type: 'saveFile', suggestedName: "CRAData.TD6"};
                    chrome.fileSystem.chooseEntry(config, function(writableEntry) {
                        var blob = new Blob([(new XMLSerializer()).serializeToString(XmlDoc)], {type: 'text/TD6'});
                        writeFileEntry(writableEntry, blob, function(e) {
                            document.getElementById('lblMsg').innerHTML="File saved successfully. Use menu Tax Return->Auto-fill My Return->Import CRA Data of TaxFreeway to import from the saved file.";
                            document.getElementById("stop").disabled = true;            
                       });
                    });
                }
            }
            else {
                showDialogBox("Server failure with return code: " + returnCode);
            }
        }
        else if (currNode.localName == "SystemError") {
            setSoapFieldsTDD(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "FileReturnResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "Confirmation") {
            setSoapFieldsTDD(currNode);
        }
        else if (currNode.localName == "ProcessingError") {
            setSoapFieldsTDD(currNode);
        }
        else if (currNode.localName == "Rejection") {
            setSoapFieldsTDD(currNode);
        }
        else if (currNode.localName == "SystemError") {
            setSoapFieldsTDD(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "Fault") {
        SoapReceivedOK = false;
        showDialogBox("Soap fault: " + currNode.childNodes[1].textContent);
    }
    else {
        SoapReceivedOK = false;
        showDialogBox("Unrecognized response type:" + currNode.localName);
    }
}
function setSoapFieldsTDD(currNode) {
    var currEnNode;
    var currFrNode;
    var i;
    var j;
    var offset;
    SoapResponseType = currNode.localName;
    if (currNode.localName == "Confirmation") {
    	ConfirmationCode = currNode.firstChild.textContent;
        currEnNode = currNode.childNodes[1];
       offset = 1;
    }
    else {
        currEnNode = currNode.firstChild;
        offset = 0;
    }
    soapMsgTextEn = currEnNode.firstChild.textContent;
    for (i = 1; i<= currEnNode.childNodes.length - 1; i++) {
        if (currEnNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + "<a href='" + currEnNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currEnNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + currEnNode.childNodes[i].textContent;
        }
    }
    currFrNode = currNode.childNodes[1 + offset];
    soapMsgTextFr = currFrNode.firstChild.textContent;
    for (i = 1; i <= currFrNode.childNodes.length - 1; i++) {
        if (currFrNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + "<a href='" + currFrNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currFrNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + currFrNode.childNodes[i].textContent;
        }
    }
    if (SoapResponseType == "Confirmation") {
        return;
    }
    for (i = 2; i<= currNode.childNodes.length - 1; i++) {
    	errorCode[i - 2] = currNode.childNodes[i].firstChild.textContent;
        for (j = 0; j<= currNode.childNodes[i].childNodes[1].childNodes.length - 1; j++) {
            errorMsgEn[i - 2] = errorMsgEn[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[1].childNodes[j].textContent;
        }
        for (j = 0; j <= currNode.childNodes[i].childNodes[2].childNodes.length - 1; j++) {
            errorMsgFr[i - 2] = errorMsgFr[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[2].childNodes[j].textContent;
        }
    }
}
function getErrorCode(index) {
    return errorCode[index];
}
function getErrorMsgEn(index) {
    return errorMsgEn[index];
}
function getErrorMsgFr(index) {
    return errorMsgFr[index];
}
function errorHandler(e) {
  console.error(e);
}
function writeFileEntry(writableEntry, opt_blob, callback) {
  if (!writableEntry) {
      showDialogBox("File is not saved.");
      return;
  }

  writableEntry.createWriter(function(writer) {

    writer.onerror = errorHandler;
    writer.onwriteend = callback;

    // If we have data, write it to the file. Otherwise, just use the file we
    // loaded.
    if (opt_blob) {
      writer.truncate(opt_blob.size);
      waitForIO(writer, function() {
        writer.seek(0);
        writer.write(opt_blob);
      });
    } 
    else {
        showDialogBox("Nothing to save.");
    }
  }, errorHandler);
}

function waitForIO(writer, callback) {
  // set a watchdog to avoid eventual locking:
  var start = Date.now();
  // wait for a few seconds
  var reentrant = function() {
    if (writer.readyState===writer.WRITING && Date.now()-start<4000) {
      setTimeout(reentrant, 100);
      return;
    }
    if (writer.readyState===writer.WRITING) {
      console.error("Write operation taking too long, aborting!"+
        " (current writer readyState is "+writer.readyState+")");
      writer.abort();
    } 
    else {
      callback();
    }
  };
  setTimeout(reentrant, 100);
}

var SecondsSince1970;
var UTCString;
var SIN;
var tokenFromCRA = "";
var TDDResend;

window.addEventListener("load", function(e) {
    document.querySelector('#CRATDDOK').addEventListener("click", function(evt) {
      enterSIN();
    });
    document.querySelector('#SINOK').addEventListener("click", function(evt) {
      showCRATDD();
    });
    document.querySelector('#CRATDDCancel').addEventListener("click", function(evt) {
      showSelectFunction();
    });
    document.querySelector('#CRATDDBack').addEventListener("click", function(evt) {
      showSelectFunction1();
    });
    document.querySelector('#SINCancel').addEventListener("click", function(evt) {
      showSelectFunction2();
    });
})
function enterSIN()
{
    document.getElementById('tddMsg15').style.display="none";
    document.getElementById('tddMsg16').style.display="none";
    document.getElementById('tddButtons').style.display="none";
    document.getElementById('enterSIN').style.display="block";
}
function showCRATDD()
{
    SIN = document.getElementById('SIN').value
    if (SIN.length == 0) {
        showDialogBox("Please enter SIN.");
	return;
    }
    if (SIN.length != 9) {
        showDialogBox("Length of SIN should be 9.");
        return;
    }
    if (isNaN(Number(SIN))) {
        showDialogBox("SIN should be a number.");
        return
    }

    document.getElementById('enterSIN').style.display="none";
    connect2NTP(1);
}
function connect2NTP(mode) {
    chrome.sockets.tcp.create({},
            function (createInfo) {
                console.log(createInfo.socketId);
                   chrome.sockets.tcp.connect(createInfo.socketId,
                        "time4.nrc.ca", 37,
                        function (result) {
                            if (chrome.runtime.lastError) {
                                    console.log(chrome.runtime.lastError.message);
                        document.getElementById('NTPAccess').style.display="block";
                        document.getElementById('NTPError').innerHTML = "Failed to connect to NTP server for accurate time: " + chrome.runtime.lastError.message;
                        return;
                    }
                            else {
                                    console.log(result);
                                    chrome.sockets.tcp.onReceive.addListener(listener =
                                           function (info) {
                                                if (info.data)
                                                       console.log(ab2seconds(info.data));
                                               var d = new Date();
                                               SecondsSince1970 = ab2seconds(info.data) - 2208988800;
                                               d.setTime(SecondsSince1970 * 1000);
                                               console.log(d.toLocaleString());
                                               console.log(d.toUTCString());
                                               UTCString = d.getUTCFullYear() + "-"
                                               UTCString += (((d.getUTCMonth() + 1) < 10) ? ("0" + (d.getUTCMonth() + 1)) : (d.getUTCMonth() + 1)) + "-";
                                               UTCString += ((d.getUTCDate() < 10) ? ("0" + d.getUTCDate()) : d.getUTCDate()) + "T";
                                               UTCString += ((d.getUTCHours() < 10) ? ("0" + d.getUTCHours()) : d.getUTCHours()) + ":";
                                               UTCString += ((d.getUTCMinutes() < 10) ? ("0" + d.getUTCMinutes()) : d.getUTCMinutes()) + ":";
                                               UTCString += ((d.getUTCSeconds() < 10) ? ("0" + d.getUTCSeconds()) : d.getUTCSeconds()) + ".0000000Z";
                                               console.log(UTCString);
                                               if (mode == 1) {
                                                   var xmlDoc1 = loadXMLDocStageTDD(taxYear + "/stageTDD.xml");
                                               }
                                               else if (mode == 2) {
                                                   var xmlDoc1 = loadXMLDocGetTDD(taxYear + "/getTDD.xml");
                                               }
                                               chrome.sockets.tcp.disconnect(createInfo.socketId);
                                               chrome.sockets.tcp.close(createInfo.socketId);
                                               chrome.sockets.tcp.onReceive.removeListener(listener);
                                               return;
                                           }
                                    );
                               }
                        }
                );
            }
    );
}
function showSelectFunction()
{
    document.getElementById('tddMsg15').style.display="none";
    document.getElementById('tddMsg16').style.display="none";
    document.getElementById('tddButtons').style.display="none";
    document.getElementById('selectFunction').style.display="block";
}
function showSelectFunction1()
{
    document.getElementById('NTPAccess').style.display="none";
    document.getElementById('selectFunction').style.display="block";
}
function showSelectFunction2()
{
    document.getElementById('enterSIN').style.display="none";
    document.getElementById('selectFunction').style.display="block";
}
function ab2seconds(buf) {
//  return String.fromCharCode.apply(null, new Uint16Array(buf));
    var bufView = new Uint8Array(buf);
    var value = 0;
    value = bufView[0] * 256;
    value = (value + bufView[1]) * 256;
    value = (value + bufView[2]) * 256;
    value = value + bufView[3];
    return value;
}
function showCRATDD1() {
     document.getElementById('lblMsg').innerHTML="No connection";
    document.getElementById('cratdd').style.display="block";
}
function showCRAWeb() {
    var CRAWebAppURL;
    if (CRAEPS) {
        CRAWebAppURL = "https://apps-ct.cra-arc.gc.ca/ebci/awsc/tdd/certtest/auth/start";
    }
    else {
        CRAWebAppURL = "https://ams-sga.cra-arc.gc.ca/gol-ged/awsc/tdd/auth/start";
    }
    var tmpUrl = CRAWebAppURL;
    tmpUrl = CRAWebAppURL
    if (taxYear == 2015) {
        tmpUrl += "?spID=" + "102N";
    }
    else {
        tmpUrl += "?spID=" + "104N";
    }
    tmpUrl += "&timestamp=" + SecondsSince1970;
    tmpUrl += "&auth=" + encodeURIComponent("/gol-ged/awsc/tdd/ws");
    var baseStr;
    if (taxYear == 2015) {
        baseStr = "102N";
    }
    else {
        baseStr = "104N";
    }
    baseStr += encodeURIComponent(CRAWebAppURL.substring(8));
    baseStr += SecondsSince1970; 
    baseStr += encodeURIComponent("/gol-ged/awsc/tdd/ws");
    baseStr += "en";
    baseStr += encodeURIComponent(tokenFromCRA);
    if (taxYear != 2015) {
        baseStr += taxYear;
    }
//    console.log(baseStr);
    var signedKey = "";
    var shaObj = new jsSHA("SHA-256","TEXT");
    shaObj.setHMACKey(CRATDDSecretKey, "TEXT");
    shaObj.update(baseStr);
    signedKey = shaObj.getHMAC("B64");
//    console.log(signedKey);
    tmpUrl += "&key=" + encodeURIComponent(signedKey);
    tmpUrl += "&t=" + encodeURIComponent(tokenFromCRA);
    tmpUrl += "&lang=en";
    if (taxYear != 2015) {
        tmpUrl += "&swtaxyear=" + taxYear;
    }
    console.log(tmpUrl);
//    window.open(tmpUrl);
    openInChrome(tmpUrl); 
}
// Open new window in Chrome instead of default browser.
// app window
function openInChrome(url) {
  chrome.runtime.sendMessage({action: "openURL", url: url});
}
var termlinkClicked = true;
window.addEventListener("load", function(e) {
	document.querySelector('#showTerm').addEventListener("click", function(evt) {
	  loadTerm();
	});
	document.querySelector('#acceptTerm').addEventListener("click", function(evt) {
	  acceptTerm();
	});
})
function loadTerm()
{
	var xmlDoc1 = loadXMLDoc("soapTerm.xml");
	document.getElementById('selectNetfile').style.display="none";
	document.getElementById('fileList').style.display="none";
	document.getElementById('termConditionBtn').style.display="none";
	document.getElementById('termCondition').style.display="block";
}
function setTermLink() {
	termlinkClicked = true;
}
function acceptTerm()
{
	if (!document.getElementById('chkboxTerm').checked) {	
		showDialogBox("Tick the checkbox to agree with the Terms and Conditions.")
		return;
	}
	if (!termlinkClicked) {
		showDialogBox("Please first click the NETFILE Terms and Conditions and Privacy Notice link to show the terms and conditions.");
		return;
	}
	document.getElementById('termCondition').style.display="none";
	document.getElementById('acceptTermBtn').style.display="none";
//	document.getElementById('selectNetfile').style.display="block";
//	document.getElementById('fileList').style.display="block";
	document.getElementById('uploadBtn').style.display="block";
}
window.addEventListener("load", function(e) {
	document.querySelector('#upload').addEventListener("click", function(evt) {
	  uploadNetfile();
	});
	document.querySelector('#print').addEventListener("click", function(evt) {
	  printResult();
	});
	document.querySelector('#firstTime').addEventListener("change", function(evt) {
	  showFirstTimeInfo();
	});
})
function uploadNetfile()
{
	if (fileContent == null) {
		showDialogBox1("No File selected", "Please select a XML file.");
		return;
	}
	var xmlDoc1 = files[0];
//	console.log(fileContent.substring(1, 5));
	if (fileContent.substring(0, 5) != "<?xml") {
		showDialogBox1("File Format Error", "Please select a XML file.");
		return;
	}
	if (window.DOMParser) {
		var parser = new DOMParser();
  		xmlDoc1 = parser.parseFromString(fileContent,"text/xml");
	}
	else {
		// Internet Explorer 
  		xmlDoc1 = new ActiveXObject("Microsoft.XMLDOM");
  		xmlDoc1.async = false;
  		xmlDoc1.loadXML(fileContent); 
  	}
  	var softwareID = xmlDoc1.getElementsByTagName("SoftwareID")[0].textContent;
	if (softwareID != "102G" && softwareID != "104G" && softwareID != "102M" && softwareID != "104M") {
		showDialogBox1("Unknown Software", "Please select a XML file created by TaxFreeway.");
		return;
	}
    if (document.querySelector('#firstTime').checked) {
    	if (document.querySelector('#firstName').value.length == 0) {
			showDialogBox1("Field is Missing", "Please enter given name.");
			return;
    	}
    	if (document.querySelector('#secondName').value.length == 0) {
			showDialogBox1("Field is Missing", "Please enter second name.");
			return;
    	}
    	if (document.querySelector('#familyName').value.length == 0) {
			showDialogBox1("Field is Missing", "Please enter family name.");
			return;
    	}
    }
	if (document.querySelector('#fiveDayPayment').checked) {
		setSoapValue(xmlDoc1, 3, "1");
	}
	else {
		setSoapValue(xmlDoc1, 3, "2");
	}
	setSoapValue(xmlDoc1, 4, "1");
	if (document.querySelector('#firstTime').checked) {
		setSoapValue(xmlDoc1, 5, "1");
		addSoapField(xmlDoc1, "comm”, ”GivenName",document.querySelector('#firstName').value);
		addSoapField(xmlDoc1, "t1rq”, ”SecondName",document.querySelector('#secondName').value);
		addSoapField(xmlDoc1, "comm”, ”FamilyName",document.querySelector('#familyName').value);
	}
	else {
		setSoapValue(xmlDoc1, 5, "2");
	}
	makeCorsRequest(xmlDoc1, 2);
	var tmpRootNode = xmlDoc1.documentElement.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
	console.log(tmpRootNode.innerHTML);
	document.getElementById('selectNetfile').style.display="none";
	document.getElementById('fileList').style.display="none";
	document.getElementById('uploadBtn').style.display="none";
//	document.getElementById('uploadNetfile').style.display="block";
}
function loadXMLString(txt)
{
	if (window.DOMParser)
  	{
  		parser=new DOMParser();
  		xmlDoc=parser.parseFromString(txt,"text/xml");
  	}
	else // code for IE
  	{
  		xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
  		xmlDoc.async=false;
  		xmlDoc.loadXML(txt);
  	}
	return xmlDoc;
}
window.addEventListener("load", function() {
    var beforePrint = function() {
        console.log('Functionality to run before printing.');
    };
    var afterPrint = function() {
        console.log('Functionality to run after printing');
		if (window.navigator.appVersion.indexOf("Macintosh") >= 0) {
       		window.resizeTo(800, 600);
		}
    };

    if (window.matchMedia) {
        var mediaQueryList = window.matchMedia('print');
        mediaQueryList.addListener(function(mql) {
            if (mql.matches) {
                beforePrint();
            } else {
                afterPrint();
            }
        });
    }

    window.onbeforeprint = beforePrint;
    window.onafterprint = afterPrint;
});
function printResult()	{
	if (window.navigator.appVersion.indexOf("Macintosh") >= 0) {
    		window.resizeTo(800, 100);
	}
    	window.print();
}
function showFirstTimeInfo()	{
    if (document.querySelector('#firstTime').checked) {
    	document.querySelector('#firstTimeInfo').style.display = "block";
    }
    else {
    	document.querySelector('#firstTimeInfo').style.display = "none";
    	document.querySelector('#firstName').value = "";
    	document.querySelector('#secondName').value = "";
    	document.querySelector('#familyName').value = "";   	
    }
}
function setSoapValue(xmlDoc, index, xmlFieldValue) {
	var tmpXMLNode;
 	var tmpRootNode
    tmpRootNode = xmlDoc.documentElement.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
	tmpRootNode = tmpRootNode.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
    var j = 0;
	tmpXMLNode = tmpRootNode.childNodes.item(0);
    while (1) {
		if (tmpXMLNode.nodeType != 1) {
			tmpXMLNode = tmpXMLNode.nextSibling;
		}
		else {
			if (j == index) {
				break;
			}
			tmpXMLNode = tmpXMLNode.nextSibling;
			j++;
		}
    }
	tmpXMLNode.textContent = xmlFieldValue;
}
function addSoapField(xmlDoc, xmlNS, xmlFieldName, xmlFieldValue) {
	var tmpXMLNode;
	var tmpTextNode;
	var tmpRootNode;
	tmpRootNode = xmlDoc.documentElement.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
	tmpRootNode = tmpRootNode.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
//	tmpXMLNode = xmlDoc.createElement(xmlFieldName);
	tmpXMLNode = xmlDoc.createElementNS(xmlNS, xmlFieldName);
	tmpTextNode = xmlDoc.createTextNode(xmlFieldValue);
	tmpXMLNode.appendChild(tmpTextNode);
	tmpRootNode.appendChild(tmpXMLNode);
}


