var SoapDocument;
var SoapTermDocument;
var SoapReceivedOK;
var SoapResponseType;
var termTextEn;
var termTextFr;
var ConfirmationCode;
var soapMsgTextEn;
var soapMsgTextFr;
var errorCode = new Array(16);
var errorMsgEn = new Array(16);
var errorMsgFr = new Array(16);

function ResponseHandler(XmlDoc) {
    //Handle the Response
    var currNode;
    var currEnNode;
    var currFrNode;
    var ErrMsgEn;
    var i;

    SoapResponseType = "";
    termTextEn = "";
    termTextFr = "";

    ConfirmationCode = "";
    soapMsgTextEn = "";
    soapMsgTextFr = "";

    for (i = 0; i<= 15; i++) {
        errorCode[i] = "";
        errorMsgEn[i] = "";
        errorMsgFr[i] = "";
    }
    currNode = XmlDoc.lastChild;
    currNode = currNode.firstChild;
    currNode = currNode.firstChild;
    if (currNode.localName == "TermsAndConditionsResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "TermsAndConditions") {
            currEnNode = currNode.firstChild;
    
            termTextEn = currEnNode.firstChild.textContent;
            for (i = 1; i <= currEnNode.childNodes.length - 1; i++) {
                if (currEnNode.childNodes[i].localName == "Hyperlink") {
                    termTextEn = termTextEn + "<br><br>";
                   termTextEn = termTextEn + "<a href='" + currEnNode.childNodes[i].childNodes[1].textContent + "' id='termlinkEn' target='_blank'>" + currEnNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
                }
                else {
                    termTextEn = termTextEn + "<br><br>";
                    termTextEn = termTextEn + currEnNode.childNodes[i].textContent;
                }
            }
            currFrNode = currNode.childNodes[1];
            termTextFr = currFrNode.firstChild.textContent;
            for (i = 1; i<= currFrNode.childNodes.length - 1; i++) {
                if (currFrNode.childNodes[i].localName == "Hyperlink") {
                    termTextFr = termTextFr + "<br><br>";
                    termTextFr = termTextFr + "<a href='" + currFrNode.childNodes[i].childNodes[1].textContent + "' id='termlinkFr' target='_blank'>" + currFrNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
                }
                else {
                    termTextFr = termTextFr + "<br><br>";
                    termTextFr = termTextFr + currFrNode.childNodes(i).textContent;
                }
            }
        }
        else if (currNode.localName == "SystemError") {
            setSoapFields(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "FileReturnResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "Confirmation") {
            setSoapFields(currNode);
        }
        else if (currNode.localName == "ProcessingError") {
            setSoapFields(currNode);
        }
        else if (currNode.localName == "Rejection") {
            setSoapFields(currNode);
        }
        else if (currNode.localName == "SystemError") {
            setSoapFields(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "Fault") {
        SoapReceivedOK = false;
        showDialogBox("Soap fault: " + currNode.childNodes[1].textContent);
    }
    else {
        SoapReceivedOK = false;
        showDialogBox("Unrecognized response type:" + currNode.localName);
    }
}
function setSoapFields(currNode) {
    var currEnNode;
    var currFrNode;
    var i;
    var j;
    var offset;
    SoapResponseType = currNode.localName;
    if (currNode.localName == "Confirmation") {
    	ConfirmationCode = currNode.firstChild.textContent;
        currEnNode = currNode.childNodes[1];
       offset = 1;
    }
    else {
        currEnNode = currNode.firstChild;
        offset = 0;
    }
    soapMsgTextEn = currEnNode.firstChild.textContent;
    for (i = 1; i<= currEnNode.childNodes.length - 1; i++) {
        if (currEnNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + "<a href='" + currEnNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currEnNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + currEnNode.childNodes[i].textContent;
        }
    }
    currFrNode = currNode.childNodes[1 + offset];
    soapMsgTextFr = currFrNode.firstChild.textContent;
    for (i = 1; i <= currFrNode.childNodes.length - 1; i++) {
        if (currFrNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + "<a href='" + currFrNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currFrNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + currFrNode.childNodes[i].textContent;
        }
    }
    if (SoapResponseType == "Confirmation") {
        return;
    }
    for (i = 2; i<= currNode.childNodes.length - 1; i++) {
    	errorCode[i - 2] = currNode.childNodes[i].firstChild.textContent;
        for (j = 0; j<= currNode.childNodes[i].childNodes[1].childNodes.length - 1; j++) {
            errorMsgEn[i - 2] = errorMsgEn[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[1].childNodes[j].textContent;
        }
        for (j = 0; j <= currNode.childNodes[i].childNodes[2].childNodes.length - 1; j++) {
            errorMsgFr[i - 2] = errorMsgFr[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[2].childNodes[j].textContent;
        }
    }
}
function getErrorCode(index) {
    return errorCode[index];
}
function getErrorMsgEn(index) {
    return errorMsgEn[index];
}
function getErrorMsgFr(index) {
    return errorMsgFr[index];
}

