var SoapDocument;
var SoapTermDocument;
var SoapReceivedOK;
var SoapResponseType;
var termTextEn;
var termTextFr;
var ConfirmationCode;
var soapMsgTextEn;
var soapMsgTextFr;
var errorCode = new Array(16);
var errorMsgEn = new Array(16);
var errorMsgFr = new Array(16);

function ResponseHandlerTDD(XmlDoc) {
    //Handle the Response
    var currNode;
    var currEnNode;
    var currFrNode;
    var ErrMsgEn;
    var i;
    var returnCode;

    SoapResponseType = "";
    termTextEn = "";
    termTextFr = "";

    ConfirmationCode = "";
    soapMsgTextEn = "";
    soapMsgTextFr = "";

    for (i = 0; i<= 15; i++) {
        errorCode[i] = "";
        errorMsgEn[i] = "";
        errorMsgFr[i] = "";
    }
    currNode = XmlDoc.lastChild;
    currNode = currNode.firstChild;
    while (currNode.nodeType != 1) {
        currNode = currNode.nextSibling;
    }
    currNode = currNode.firstChild;
    while (currNode.nodeType != 1) {
        currNode = currNode.nextSibling;
    }
    if (currNode.localName == "StageTDDNetfileResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "ReturnCode") {
            returnCode = currNode.textContent;
             if (returnCode == "0") {
                currNode = currNode.nextSibling;
                if (currNode.localName == "TokenIdentifier") {
                    tokenFromCRA = currNode.textContent;
                    showCRATDD1();
                }
                else {
                    showDialogBox("Undefined soap response element: " + currNode.localName);
                }
            }
            else {
                showDialogBox("Server failure with return code: " + returnCode);
            }
        }
        else if (currNode.localName == "SystemError") {
            setSoapFieldsTDD(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "GetTDDNetfileResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "ReturnCode") {
            returnCode = currNode.textContent;
             if (returnCode == "0") {
                currNode = currNode.nextSibling;
                if (currNode.localName == "TokenIdentifier") {
                    tokenFromCRA = currNode.textContent;
                }
                else {
                    showDialogBox("Undefined soap response element: " + currNode.localName);
                }
                setTimeout(function(){connect2NTP(2)}, 5000);
           }
           else if (returnCode == "10") {
                currNode = currNode.nextSibling;
                if (currNode.localName == "TokenIdentifier") {
                    tokenFromCRA = currNode.textContent;
                }
                else {
                    showDialogBox("Undefined soap response element: " + currNode.localName);
                }
                if (TDDResend) {
                    setTimeout(function(){connect2NTP(2)}, 5000);
                }
           }
           else if (returnCode == "20") {
                if (taxYear == 2015) {
                    document.getElementById('lblMsg').innerHTML="Save CRA data to a .TD5 file.";
                    var config = {type: 'saveFile', suggestedName: "CRAData.TD5"};
                    chrome.fileSystem.chooseEntry(config, function(writableEntry) {
                        var blob = new Blob([(new XMLSerializer()).serializeToString(XmlDoc)], {type: 'text/TD5'});
                        writeFileEntry(writableEntry, blob, function(e) {
                            document.getElementById('lblMsg').innerHTML="File saved successfully. Use menu Tax Return->Auto-fill My Return->Import CRA Data of TaxFreeway to import from the saved file.";
                            document.getElementById("stop").disabled = true;            
                       });
                    });
                }
                else {
                    document.getElementById('lblMsg').innerHTML="Save CRA data to a .TD6 file.";
                    var config = {type: 'saveFile', suggestedName: "CRAData.TD6"};
                    chrome.fileSystem.chooseEntry(config, function(writableEntry) {
                        var blob = new Blob([(new XMLSerializer()).serializeToString(XmlDoc)], {type: 'text/TD6'});
                        writeFileEntry(writableEntry, blob, function(e) {
                            document.getElementById('lblMsg').innerHTML="File saved successfully. Use menu Tax Return->Auto-fill My Return->Import CRA Data of TaxFreeway to import from the saved file.";
                            document.getElementById("stop").disabled = true;            
                       });
                    });
                }
            }
            else {
                showDialogBox("Server failure with return code: " + returnCode);
            }
        }
        else if (currNode.localName == "SystemError") {
            setSoapFieldsTDD(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "FileReturnResponse") {
        currNode = currNode.firstChild;
        SoapResponseType = currNode.localName;
        if (currNode.localName == "Confirmation") {
            setSoapFieldsTDD(currNode);
        }
        else if (currNode.localName == "ProcessingError") {
            setSoapFieldsTDD(currNode);
        }
        else if (currNode.localName == "Rejection") {
            setSoapFieldsTDD(currNode);
        }
        else if (currNode.localName == "SystemError") {
            setSoapFieldsTDD(currNode);
        }
        else {
            SoapReceivedOK = false;
            showDialogBox("Undefined soap response type: " + currNode.localName);
        }
    }
    else if (currNode.localName == "Fault") {
        SoapReceivedOK = false;
        showDialogBox("Soap fault: " + currNode.childNodes[1].textContent);
    }
    else {
        SoapReceivedOK = false;
        showDialogBox("Unrecognized response type:" + currNode.localName);
    }
}
function setSoapFieldsTDD(currNode) {
    var currEnNode;
    var currFrNode;
    var i;
    var j;
    var offset;
    SoapResponseType = currNode.localName;
    if (currNode.localName == "Confirmation") {
    	ConfirmationCode = currNode.firstChild.textContent;
        currEnNode = currNode.childNodes[1];
       offset = 1;
    }
    else {
        currEnNode = currNode.firstChild;
        offset = 0;
    }
    soapMsgTextEn = currEnNode.firstChild.textContent;
    for (i = 1; i<= currEnNode.childNodes.length - 1; i++) {
        if (currEnNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + "<a href='" + currEnNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currEnNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextEn = soapMsgTextEn + "<br><br>";
            soapMsgTextEn = soapMsgTextEn + currEnNode.childNodes[i].textContent;
        }
    }
    currFrNode = currNode.childNodes[1 + offset];
    soapMsgTextFr = currFrNode.firstChild.textContent;
    for (i = 1; i <= currFrNode.childNodes.length - 1; i++) {
        if (currFrNode.childNodes[i].localName == "Hyperlink") {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + "<a href='" + currFrNode.childNodes[i].childNodes[1].textContent + "' target='_blank'>" + currFrNode.childNodes[i].firstChild.textContent + "</a></p>" + "\n";
        }
        else {
            soapMsgTextFr = soapMsgTextFr + "<br><br>";
            soapMsgTextFr = soapMsgTextFr + currFrNode.childNodes[i].textContent;
        }
    }
    if (SoapResponseType == "Confirmation") {
        return;
    }
    for (i = 2; i<= currNode.childNodes.length - 1; i++) {
    	errorCode[i - 2] = currNode.childNodes[i].firstChild.textContent;
        for (j = 0; j<= currNode.childNodes[i].childNodes[1].childNodes.length - 1; j++) {
            errorMsgEn[i - 2] = errorMsgEn[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[1].childNodes[j].textContent;
        }
        for (j = 0; j <= currNode.childNodes[i].childNodes[2].childNodes.length - 1; j++) {
            errorMsgFr[i - 2] = errorMsgFr[i - 2] + "<br><br>" + currNode.childNodes[i].childNodes[2].childNodes[j].textContent;
        }
    }
}
function getErrorCode(index) {
    return errorCode[index];
}
function getErrorMsgEn(index) {
    return errorMsgEn[index];
}
function getErrorMsgFr(index) {
    return errorMsgFr[index];
}
function errorHandler(e) {
  console.error(e);
}
function writeFileEntry(writableEntry, opt_blob, callback) {
  if (!writableEntry) {
      showDialogBox("File is not saved.");
      return;
  }

  writableEntry.createWriter(function(writer) {

    writer.onerror = errorHandler;
    writer.onwriteend = callback;

    // If we have data, write it to the file. Otherwise, just use the file we
    // loaded.
    if (opt_blob) {
      writer.truncate(opt_blob.size);
      waitForIO(writer, function() {
        writer.seek(0);
        writer.write(opt_blob);
      });
    } 
    else {
        showDialogBox("Nothing to save.");
    }
  }, errorHandler);
}

function waitForIO(writer, callback) {
  // set a watchdog to avoid eventual locking:
  var start = Date.now();
  // wait for a few seconds
  var reentrant = function() {
    if (writer.readyState===writer.WRITING && Date.now()-start<4000) {
      setTimeout(reentrant, 100);
      return;
    }
    if (writer.readyState===writer.WRITING) {
      console.error("Write operation taking too long, aborting!"+
        " (current writer readyState is "+writer.readyState+")");
      writer.abort();
    } 
    else {
      callback();
    }
  };
  setTimeout(reentrant, 100);
}

