window.addEventListener("load", function(e) {
	document.querySelector('#upload').addEventListener("click", function(evt) {
	  uploadNetfile();
	});
	document.querySelector('#print').addEventListener("click", function(evt) {
	  printResult();
	});
	document.querySelector('#firstTime').addEventListener("change", function(evt) {
	  showFirstTimeInfo();
	});
})
function uploadNetfile()
{
	if (fileContent == null) {
		showDialogBox1("No File selected", "Please select a XML file.");
		return;
	}
	var xmlDoc1 = files[0];
//	console.log(fileContent.substring(1, 5));
	if (fileContent.substring(0, 5) != "<?xml") {
		showDialogBox1("File Format Error", "Please select a XML file.");
		return;
	}
	if (window.DOMParser) {
		var parser = new DOMParser();
  		xmlDoc1 = parser.parseFromString(fileContent,"text/xml");
	}
	else {
		// Internet Explorer 
  		xmlDoc1 = new ActiveXObject("Microsoft.XMLDOM");
  		xmlDoc1.async = false;
  		xmlDoc1.loadXML(fileContent); 
  	}
  	var softwareID = xmlDoc1.getElementsByTagName("SoftwareID")[0].textContent;
	if (softwareID != "102G" && softwareID != "104G" && softwareID != "102M" && softwareID != "104M") {
		showDialogBox1("Unknown Software", "Please select a XML file created by TaxFreeway.");
		return;
	}
    if (document.querySelector('#firstTime').checked) {
    	if (document.querySelector('#firstName').value.length == 0) {
			showDialogBox1("Field is Missing", "Please enter given name.");
			return;
    	}
    	if (document.querySelector('#secondName').value.length == 0) {
			showDialogBox1("Field is Missing", "Please enter second name.");
			return;
    	}
    	if (document.querySelector('#familyName').value.length == 0) {
			showDialogBox1("Field is Missing", "Please enter family name.");
			return;
    	}
    }
	if (document.querySelector('#fiveDayPayment').checked) {
		setSoapValue(xmlDoc1, 3, "1");
	}
	else {
		setSoapValue(xmlDoc1, 3, "2");
	}
	setSoapValue(xmlDoc1, 4, "1");
	if (document.querySelector('#firstTime').checked) {
		setSoapValue(xmlDoc1, 5, "1");
		addSoapField(xmlDoc1, "comm”, ”GivenName",document.querySelector('#firstName').value);
		addSoapField(xmlDoc1, "t1rq”, ”SecondName",document.querySelector('#secondName').value);
		addSoapField(xmlDoc1, "comm”, ”FamilyName",document.querySelector('#familyName').value);
	}
	else {
		setSoapValue(xmlDoc1, 5, "2");
	}
	makeCorsRequest(xmlDoc1, 2);
	var tmpRootNode = xmlDoc1.documentElement.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
	console.log(tmpRootNode.innerHTML);
	document.getElementById('selectNetfile').style.display="none";
	document.getElementById('fileList').style.display="none";
	document.getElementById('uploadBtn').style.display="none";
//	document.getElementById('uploadNetfile').style.display="block";
}
function loadXMLString(txt)
{
	if (window.DOMParser)
  	{
  		parser=new DOMParser();
  		xmlDoc=parser.parseFromString(txt,"text/xml");
  	}
	else // code for IE
  	{
  		xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
  		xmlDoc.async=false;
  		xmlDoc.loadXML(txt);
  	}
	return xmlDoc;
}
window.addEventListener("load", function() {
    var beforePrint = function() {
        console.log('Functionality to run before printing.');
    };
    var afterPrint = function() {
        console.log('Functionality to run after printing');
		if (window.navigator.appVersion.indexOf("Macintosh") >= 0) {
       		window.resizeTo(800, 600);
		}
    };

    if (window.matchMedia) {
        var mediaQueryList = window.matchMedia('print');
        mediaQueryList.addListener(function(mql) {
            if (mql.matches) {
                beforePrint();
            } else {
                afterPrint();
            }
        });
    }

    window.onbeforeprint = beforePrint;
    window.onafterprint = afterPrint;
});
function printResult()	{
	if (window.navigator.appVersion.indexOf("Macintosh") >= 0) {
    		window.resizeTo(800, 100);
	}
    	window.print();
}
function showFirstTimeInfo()	{
    if (document.querySelector('#firstTime').checked) {
    	document.querySelector('#firstTimeInfo').style.display = "block";
    }
    else {
    	document.querySelector('#firstTimeInfo').style.display = "none";
    	document.querySelector('#firstName').value = "";
    	document.querySelector('#secondName').value = "";
    	document.querySelector('#familyName').value = "";   	
    }
}
function setSoapValue(xmlDoc, index, xmlFieldValue) {
	var tmpXMLNode;
 	var tmpRootNode
    tmpRootNode = xmlDoc.documentElement.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
	tmpRootNode = tmpRootNode.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
    var j = 0;
	tmpXMLNode = tmpRootNode.childNodes.item(0);
    while (1) {
		if (tmpXMLNode.nodeType != 1) {
			tmpXMLNode = tmpXMLNode.nextSibling;
		}
		else {
			if (j == index) {
				break;
			}
			tmpXMLNode = tmpXMLNode.nextSibling;
			j++;
		}
    }
	tmpXMLNode.textContent = xmlFieldValue;
}
function addSoapField(xmlDoc, xmlNS, xmlFieldName, xmlFieldValue) {
	var tmpXMLNode;
	var tmpTextNode;
	var tmpRootNode;
	tmpRootNode = xmlDoc.documentElement.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
	tmpRootNode = tmpRootNode.childNodes.item(0);
    while (tmpRootNode.nodeType != 1) {
    	tmpRootNode = tmpRootNode.nextSibling;
    }
//	tmpXMLNode = xmlDoc.createElement(xmlFieldName);
	tmpXMLNode = xmlDoc.createElementNS(xmlNS, xmlFieldName);
	tmpTextNode = xmlDoc.createTextNode(xmlFieldValue);
	tmpXMLNode.appendChild(tmpTextNode);
	tmpRootNode.appendChild(tmpXMLNode);
}


